//line php5/php5.y:2
package php5

import __yyfmt__ "fmt"

//line php5/php5.y:2
import (
	//    "fmt"
	//    "strings"
	"strconv"

	"github.com/z7zmey/php-parser/node"
	"github.com/z7zmey/php-parser/node/expr"
	"github.com/z7zmey/php-parser/node/expr/assign_op"
	"github.com/z7zmey/php-parser/node/name"
	"github.com/z7zmey/php-parser/node/scalar"
	"github.com/z7zmey/php-parser/node/stmt"
	"github.com/z7zmey/php-parser/token"

//    "github.com/z7zmey/php-parser/node/expr/binary_op"
//    "github.com/z7zmey/php-parser/node/expr/cast"
)

//line php5/php5.y:22
type yySymType struct {
	yys   int
	node  node.Node
	token token.Token
	//    boolWithToken boolWithToken
	list                    []node.Node
	foreachVariable         foreachVariable
	nodesWithEndToken       *nodesWithEndToken
	simpleIndirectReference simpleIndirectReference
	objectPropertyList      []objectProperty
	//    str string
}

const T_INCLUDE = 57346
const T_INCLUDE_ONCE = 57347
const T_EXIT = 57348
const T_IF = 57349
const T_LNUMBER = 57350
const T_DNUMBER = 57351
const T_STRING = 57352
const T_STRING_VARNAME = 57353
const T_VARIABLE = 57354
const T_NUM_STRING = 57355
const T_INLINE_HTML = 57356
const T_CHARACTER = 57357
const T_BAD_CHARACTER = 57358
const T_ENCAPSED_AND_WHITESPACE = 57359
const T_CONSTANT_ENCAPSED_STRING = 57360
const T_ECHO = 57361
const T_DO = 57362
const T_WHILE = 57363
const T_ENDWHILE = 57364
const T_FOR = 57365
const T_ENDFOR = 57366
const T_FOREACH = 57367
const T_ENDFOREACH = 57368
const T_DECLARE = 57369
const T_ENDDECLARE = 57370
const T_AS = 57371
const T_SWITCH = 57372
const T_ENDSWITCH = 57373
const T_CASE = 57374
const T_DEFAULT = 57375
const T_BREAK = 57376
const T_CONTINUE = 57377
const T_GOTO = 57378
const T_FUNCTION = 57379
const T_CONST = 57380
const T_RETURN = 57381
const T_TRY = 57382
const T_CATCH = 57383
const T_FINALLY = 57384
const T_THROW = 57385
const T_USE = 57386
const T_INSTEADOF = 57387
const T_GLOBAL = 57388
const T_VAR = 57389
const T_UNSET = 57390
const T_ISSET = 57391
const T_EMPTY = 57392
const T_HALT_COMPILER = 57393
const T_CLASS = 57394
const T_TRAIT = 57395
const T_INTERFACE = 57396
const T_EXTENDS = 57397
const T_IMPLEMENTS = 57398
const T_OBJECT_OPERATOR = 57399
const T_DOUBLE_ARROW = 57400
const T_LIST = 57401
const T_ARRAY = 57402
const T_CALLABLE = 57403
const T_CLASS_C = 57404
const T_TRAIT_C = 57405
const T_METHOD_C = 57406
const T_FUNC_C = 57407
const T_LINE = 57408
const T_FILE = 57409
const T_COMMENT = 57410
const T_DOC_COMMENT = 57411
const T_OPEN_TAG = 57412
const T_OPEN_TAG_WITH_ECHO = 57413
const T_CLOSE_TAG = 57414
const T_WHITESPACE = 57415
const T_START_HEREDOC = 57416
const T_END_HEREDOC = 57417
const T_DOLLAR_OPEN_CURLY_BRACES = 57418
const T_CURLY_OPEN = 57419
const T_PAAMAYIM_NEKUDOTAYIM = 57420
const T_NAMESPACE = 57421
const T_NS_C = 57422
const T_DIR = 57423
const T_NS_SEPARATOR = 57424
const T_ELLIPSIS = 57425
const T_EVAL = 57426
const T_REQUIRE = 57427
const T_REQUIRE_ONCE = 57428
const T_LOGICAL_OR = 57429
const T_LOGICAL_XOR = 57430
const T_LOGICAL_AND = 57431
const T_INSTANCEOF = 57432
const T_NEW = 57433
const T_CLONE = 57434
const T_ELSEIF = 57435
const T_ELSE = 57436
const T_ENDIF = 57437
const T_PRINT = 57438
const T_YIELD = 57439
const T_STATIC = 57440
const T_ABSTRACT = 57441
const T_FINAL = 57442
const T_PRIVATE = 57443
const T_PROTECTED = 57444
const T_PUBLIC = 57445
const T_INC = 57446
const T_DEC = 57447
const T_YIELD_FROM = 57448
const T_INT_CAST = 57449
const T_DOUBLE_CAST = 57450
const T_STRING_CAST = 57451
const T_ARRAY_CAST = 57452
const T_OBJECT_CAST = 57453
const T_BOOL_CAST = 57454
const T_UNSET_CAST = 57455
const T_COALESCE = 57456
const T_SPACESHIP = 57457
const T_NOELSE = 57458
const T_PLUS_EQUAL = 57459
const T_MINUS_EQUAL = 57460
const T_MUL_EQUAL = 57461
const T_DIV_EQUAL = 57462
const T_CONCAT_EQUAL = 57463
const T_MOD_EQUAL = 57464
const T_AND_EQUAL = 57465
const T_OR_EQUAL = 57466
const T_XOR_EQUAL = 57467
const T_SL_EQUAL = 57468
const T_SR_EQUAL = 57469
const T_POW_EQUAL = 57470
const T_BOOLEAN_OR = 57471
const T_BOOLEAN_AND = 57472
const T_IS_EQUAL = 57473
const T_IS_NOT_EQUAL = 57474
const T_IS_IDENTICAL = 57475
const T_IS_NOT_IDENTICAL = 57476
const T_IS_SMALLER_OR_EQUAL = 57477
const T_IS_GREATER_OR_EQUAL = 57478
const T_SL = 57479
const T_SR = 57480
const T_POW = 57481

var yyToknames = [...]string{
	"$end",
	"error",
	"$unk",
	"T_INCLUDE",
	"T_INCLUDE_ONCE",
	"T_EXIT",
	"T_IF",
	"T_LNUMBER",
	"T_DNUMBER",
	"T_STRING",
	"T_STRING_VARNAME",
	"T_VARIABLE",
	"T_NUM_STRING",
	"T_INLINE_HTML",
	"T_CHARACTER",
	"T_BAD_CHARACTER",
	"T_ENCAPSED_AND_WHITESPACE",
	"T_CONSTANT_ENCAPSED_STRING",
	"T_ECHO",
	"T_DO",
	"T_WHILE",
	"T_ENDWHILE",
	"T_FOR",
	"T_ENDFOR",
	"T_FOREACH",
	"T_ENDFOREACH",
	"T_DECLARE",
	"T_ENDDECLARE",
	"T_AS",
	"T_SWITCH",
	"T_ENDSWITCH",
	"T_CASE",
	"T_DEFAULT",
	"T_BREAK",
	"T_CONTINUE",
	"T_GOTO",
	"T_FUNCTION",
	"T_CONST",
	"T_RETURN",
	"T_TRY",
	"T_CATCH",
	"T_FINALLY",
	"T_THROW",
	"T_USE",
	"T_INSTEADOF",
	"T_GLOBAL",
	"T_VAR",
	"T_UNSET",
	"T_ISSET",
	"T_EMPTY",
	"T_HALT_COMPILER",
	"T_CLASS",
	"T_TRAIT",
	"T_INTERFACE",
	"T_EXTENDS",
	"T_IMPLEMENTS",
	"T_OBJECT_OPERATOR",
	"T_DOUBLE_ARROW",
	"T_LIST",
	"T_ARRAY",
	"T_CALLABLE",
	"T_CLASS_C",
	"T_TRAIT_C",
	"T_METHOD_C",
	"T_FUNC_C",
	"T_LINE",
	"T_FILE",
	"T_COMMENT",
	"T_DOC_COMMENT",
	"T_OPEN_TAG",
	"T_OPEN_TAG_WITH_ECHO",
	"T_CLOSE_TAG",
	"T_WHITESPACE",
	"T_START_HEREDOC",
	"T_END_HEREDOC",
	"T_DOLLAR_OPEN_CURLY_BRACES",
	"T_CURLY_OPEN",
	"T_PAAMAYIM_NEKUDOTAYIM",
	"T_NAMESPACE",
	"T_NS_C",
	"T_DIR",
	"T_NS_SEPARATOR",
	"T_ELLIPSIS",
	"T_EVAL",
	"T_REQUIRE",
	"T_REQUIRE_ONCE",
	"T_LOGICAL_OR",
	"T_LOGICAL_XOR",
	"T_LOGICAL_AND",
	"T_INSTANCEOF",
	"T_NEW",
	"T_CLONE",
	"T_ELSEIF",
	"T_ELSE",
	"T_ENDIF",
	"T_PRINT",
	"T_YIELD",
	"T_STATIC",
	"T_ABSTRACT",
	"T_FINAL",
	"T_PRIVATE",
	"T_PROTECTED",
	"T_PUBLIC",
	"T_INC",
	"T_DEC",
	"T_YIELD_FROM",
	"T_INT_CAST",
	"T_DOUBLE_CAST",
	"T_STRING_CAST",
	"T_ARRAY_CAST",
	"T_OBJECT_CAST",
	"T_BOOL_CAST",
	"T_UNSET_CAST",
	"T_COALESCE",
	"T_SPACESHIP",
	"T_NOELSE",
	"'\"'",
	"'`'",
	"'{'",
	"'}'",
	"';'",
	"':'",
	"'('",
	"')'",
	"'['",
	"']'",
	"'?'",
	"'&'",
	"'-'",
	"'+'",
	"'!'",
	"'~'",
	"'@'",
	"'$'",
	"','",
	"'='",
	"T_PLUS_EQUAL",
	"T_MINUS_EQUAL",
	"T_MUL_EQUAL",
	"T_DIV_EQUAL",
	"T_CONCAT_EQUAL",
	"T_MOD_EQUAL",
	"T_AND_EQUAL",
	"T_OR_EQUAL",
	"T_XOR_EQUAL",
	"T_SL_EQUAL",
	"T_SR_EQUAL",
	"T_POW_EQUAL",
	"T_BOOLEAN_OR",
	"T_BOOLEAN_AND",
	"'|'",
	"'^'",
	"T_IS_EQUAL",
	"T_IS_NOT_EQUAL",
	"T_IS_IDENTICAL",
	"T_IS_NOT_IDENTICAL",
	"'<'",
	"T_IS_SMALLER_OR_EQUAL",
	"'>'",
	"T_IS_GREATER_OR_EQUAL",
	"T_SL",
	"T_SR",
	"'.'",
	"'*'",
	"'/'",
	"'%'",
	"T_POW",
}
var yyStatenames = [...]string{}

const yyEofCode = 1
const yyErrCode = 2
const yyInitialStackSize = 16

//line php5/php5.y:2257

//line yacctab:1
var yyExca = [...]int{
	-1, 1,
	1, -1,
	-2, 0,
	-1, 50,
	104, 473,
	105, 473,
	-2, 471,
	-1, 101,
	78, 370,
	-2, 449,
	-1, 113,
	78, 491,
	123, 487,
	-2, 497,
	-1, 153,
	104, 473,
	105, 473,
	-2, 471,
	-1, 203,
	121, 344,
	124, 344,
	-2, 468,
	-1, 204,
	104, 473,
	105, 473,
	121, 345,
	124, 345,
	-2, 471,
	-1, 270,
	78, 491,
	-2, 497,
	-1, 297,
	78, 372,
	-2, 451,
	-1, 301,
	123, 488,
	-2, 498,
	-1, 310,
	78, 371,
	-2, 450,
	-1, 374,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 305,
	-1, 375,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 306,
	-1, 376,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 307,
	-1, 377,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 308,
	-1, 378,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 309,
	-1, 379,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 310,
	-1, 380,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 311,
	-1, 381,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 312,
	-1, 388,
	104, 473,
	105, 473,
	-2, 471,
	-1, 439,
	123, 482,
	-2, 486,
	-1, 457,
	104, 473,
	105, 473,
	124, 554,
	135, 554,
	-2, 471,
	-1, 458,
	124, 555,
	135, 555,
	-2, 468,
	-1, 459,
	104, 473,
	105, 473,
	-2, 471,
	-1, 481,
	124, 177,
	135, 177,
	-2, 468,
	-1, 482,
	104, 473,
	105, 473,
	124, 178,
	135, 178,
	-2, 471,
	-1, 488,
	123, 512,
	-2, 556,
	-1, 494,
	123, 512,
	-2, 557,
	-1, 516,
	78, 370,
	-2, 407,
	-1, 563,
	124, 163,
	-2, 168,
	-1, 571,
	121, 346,
	124, 346,
	-2, 468,
	-1, 572,
	104, 473,
	105, 473,
	121, 347,
	124, 347,
	-2, 471,
	-1, 579,
	57, 255,
	125, 255,
	-2, 254,
	-1, 665,
	78, 372,
	-2, 409,
	-1, 694,
	124, 163,
	-2, 168,
	-1, 709,
	124, 163,
	-2, 168,
	-1, 765,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 435,
	-1, 766,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 436,
	-1, 767,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 437,
	-1, 768,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 438,
	-1, 769,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 439,
	-1, 770,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 440,
	-1, 771,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 441,
	-1, 772,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 442,
	-1, 775,
	78, 371,
	-2, 408,
	-1, 827,
	57, 250,
	-2, 252,
	-1, 881,
	37, 224,
	-2, 221,
	-1, 941,
	123, 482,
	-2, 486,
	-1, 1003,
	29, 212,
	-2, 4,
	-1, 1027,
	124, 163,
	-2, 168,
	-1, 1031,
	121, 216,
	-2, 218,
}

const yyPrivate = 57344

const yyLast = 8302

var yyAct = [...]int{

	101, 710, 1049, 997, 885, 590, 916, 828, 869, 122,
	130, 821, 199, 414, 512, 830, 447, 472, 427, 792,
	722, 712, 116, 699, 335, 117, 801, 415, 469, 439,
	386, 667, 314, 456, 97, 263, 318, 442, 327, 329,
	328, 4, 6, 5, 60, 157, 637, 539, 480, 129,
	25, 136, 2, 178, 288, 227, 227, 42, 1026, 637,
	191, 191, 137, 639, 638, 991, 142, 637, 990, 988,
	257, 639, 638, 970, 966, 969, 961, 231, 231, 865,
	266, 191, 725, 989, 1036, 43, 706, 146, 641, 968,
	38, 659, 661, 660, 662, 647, 648, 649, 640, 642,
	643, 641, 272, 297, 693, 649, 640, 642, 643, 641,
	152, 511, 984, 240, 269, 161, 250, 931, 192, 172,
	176, 175, 637, 985, 822, 310, 354, 203, 315, 319,
	191, 932, 322, 816, 177, 179, 180, 178, 178, 324,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 342,
	227, 640, 642, 643, 641, 445, 488, 120, 120, 176,
	175, 779, 113, 505, 353, 120, 309, 538, 470, 334,
	191, 501, 231, 200, 333, 295, 494, 506, 120, 240,
	1009, 125, 266, 120, 227, 502, 971, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 489, 120,
	919, 940, 825, 125, 272, 120, 231, 348, 704, 176,
	175, 576, 227, 576, 38, 616, 269, 382, 602, 705,
	419, 575, 555, 1057, 831, 161, 617, 355, 901, 603,
	702, 158, 576, 556, 231, 351, 900, 125, 391, 120,
	346, 356, 270, 174, 177, 179, 180, 178, 959, 352,
	228, 227, 417, 229, 347, 836, 777, 311, 730, 451,
	716, 300, 429, 623, 446, 446, 615, 299, 103, 232,
	389, 312, 228, 231, 614, 229, 608, 301, 441, 119,
	119, 607, 227, 132, 581, 446, 125, 119, 120, 462,
	240, 232, 829, 304, 435, 466, 1010, 133, 580, 701,
	119, 474, 475, 130, 231, 119, 228, 504, 490, 229,
	468, 508, 1053, 894, 487, 516, 431, 432, 574, 493,
	734, 302, 595, 230, 230, 232, 486, 119, 594, 733,
	588, 492, 467, 293, 292, 286, 280, 479, 4, 6,
	5, 253, 432, 431, 431, 516, 432, 252, 264, 458,
	460, 497, 500, 159, 270, 228, 1039, 1008, 229, 547,
	533, 119, 434, 125, 960, 120, 637, 912, 868, 645,
	639, 638, 481, 863, 232, 125, 860, 120, 541, 1027,
	637, 858, 845, 543, 639, 638, 815, 38, 566, 294,
	677, 618, 227, 646, 657, 658, 655, 656, 659, 661,
	660, 662, 647, 648, 649, 640, 642, 643, 641, 578,
	119, 609, 605, 424, 231, 422, 647, 648, 649, 640,
	642, 643, 641, 306, 138, 443, 927, 296, 230, 813,
	296, 804, 267, 709, 453, 268, 487, 493, 694, 448,
	666, 599, 794, 793, 228, 577, 563, 229, 486, 492,
	532, 232, 390, 339, 287, 294, 340, 1015, 277, 274,
	264, 443, 230, 232, 191, 598, 443, 273, 441, 38,
	601, 249, 600, 485, 227, 571, 944, 221, 194, 193,
	141, 121, 975, 1044, 349, 1043, 499, 119, 946, 384,
	230, 619, 308, 315, 307, 899, 231, 319, 332, 119,
	687, 688, 516, 176, 175, 134, 1023, 1018, 90, 665,
	1017, 516, 1007, 687, 688, 974, 636, 953, 516, 516,
	516, 516, 516, 911, 857, 629, 4, 6, 5, 230,
	853, 796, 789, 632, 784, 181, 182, 174, 177, 179,
	180, 178, 697, 542, 540, 537, 496, 227, 227, 227,
	393, 344, 684, 155, 566, 589, 1059, 1033, 951, 720,
	230, 566, 926, 925, 681, 266, 923, 227, 227, 231,
	231, 231, 703, 818, 721, 38, 679, 698, 689, 305,
	691, 727, 196, 443, 443, 430, 294, 272, 795, 231,
	231, 223, 224, 526, 726, 485, 909, 910, 256, 269,
	724, 686, 227, 736, 227, 849, 850, 596, 258, 125,
	125, 125, 443, 433, 873, 443, 719, 443, 634, 742,
	664, 743, 450, 526, 231, 418, 231, 740, 516, 516,
	516, 516, 516, 516, 516, 516, 516, 516, 516, 516,
	516, 516, 516, 516, 516, 516, 516, 516, 516, 516,
	516, 516, 516, 516, 516, 775, 744, 516, 565, 714,
	715, 124, 621, 622, 125, 1021, 671, 125, 625, 626,
	230, 294, 259, 260, 125, 1003, 125, 670, 567, 458,
	567, 568, 124, 568, 516, 566, 799, 778, 776, 454,
	281, 285, 227, 481, 127, 128, 631, 516, 798, 449,
	566, 814, 889, 890, 891, 888, 887, 886, 510, 566,
	820, 810, 421, 463, 231, 507, 817, 420, 788, 123,
	805, 883, 503, 321, 787, 303, 258, 884, 298, 819,
	882, 433, 802, 807, 464, 284, 320, 270, 833, 131,
	513, 258, 834, 835, 567, 831, 316, 568, 131, 294,
	781, 718, 230, 839, 499, 61, 452, 38, 258, 262,
	570, 294, 397, 433, 516, 207, 1019, 206, 294, 735,
	516, 516, 870, 812, 1050, 294, 294, 258, 708, 44,
	526, 889, 890, 891, 888, 887, 886, 162, 1020, 526,
	259, 260, 782, 227, 1056, 227, 526, 526, 526, 526,
	526, 855, 558, 929, 854, 259, 260, 566, 862, 258,
	536, 53, 44, 566, 283, 231, 861, 231, 238, 1025,
	874, 465, 259, 260, 1011, 230, 230, 230, 871, 986,
	893, 723, 227, 514, 896, 516, 981, 963, 897, 928,
	464, 259, 260, 264, 545, 230, 230, 441, 1037, 903,
	864, 898, 1032, 992, 231, 441, 516, 915, 566, 902,
	920, 964, 935, 514, 125, 38, 225, 233, 809, 746,
	922, 745, 284, 259, 260, 566, 934, 635, 593, 907,
	230, 591, 230, 258, 906, 258, 633, 630, 282, 917,
	255, 586, 917, 939, 560, 509, 516, 476, 914, 797,
	687, 688, 583, 938, 585, 584, 526, 526, 526, 526,
	526, 526, 526, 526, 526, 526, 526, 526, 526, 526,
	526, 526, 526, 526, 526, 526, 526, 526, 526, 526,
	526, 526, 526, 394, 323, 526, 965, 972, 690, 687,
	688, 948, 38, 202, 945, 896, 201, 259, 260, 259,
	260, 198, 516, 135, 592, 950, 941, 516, 933, 566,
	952, 566, 526, 732, 668, 954, 987, 956, 957, 523,
	230, 993, 973, 546, 395, 526, 254, 251, 554, 723,
	557, 516, 516, 800, 383, 579, 360, 566, 976, 359,
	1016, 977, 38, 978, 443, 1012, 1013, 358, 357, 448,
	823, 729, 443, 728, 895, 826, 827, 685, 336, 881,
	566, 1030, 1001, 1028, 1000, 1031, 999, 516, 566, 1035,
	514, 998, 996, 995, 114, 967, 936, 566, 38, 514,
	38, 1034, 38, 1042, 38, 38, 514, 514, 514, 514,
	514, 1052, 526, 1014, 566, 604, 1022, 880, 526, 526,
	879, 878, 962, 930, 38, 38, 38, 208, 209, 210,
	211, 213, 214, 215, 216, 217, 218, 219, 220, 212,
	877, 230, 876, 230, 478, 1038, 713, 711, 1004, 943,
	856, 913, 569, 892, 398, 40, 1046, 208, 209, 210,
	211, 213, 214, 215, 216, 217, 218, 219, 220, 212,
	38, 1060, 717, 564, 271, 396, 39, 562, 872, 14,
	230, 13, 1058, 526, 1055, 1048, 38, 866, 1047, 1045,
	1024, 883, 955, 867, 38, 811, 707, 884, 924, 806,
	882, 559, 195, 385, 526, 163, 338, 947, 38, 683,
	140, 680, 535, 139, 908, 937, 514, 514, 514, 514,
	514, 514, 514, 514, 514, 514, 514, 514, 514, 514,
	514, 514, 514, 514, 514, 514, 514, 514, 514, 514,
	514, 514, 514, 345, 526, 514, 851, 786, 534, 848,
	785, 889, 890, 891, 888, 887, 886, 678, 208, 209,
	210, 211, 213, 214, 215, 216, 217, 218, 219, 220,
	212, 331, 514, 875, 1, 838, 739, 440, 958, 289,
	455, 160, 156, 317, 637, 514, 271, 645, 639, 638,
	313, 126, 10, 248, 74, 75, 115, 265, 63, 994,
	526, 1002, 88, 582, 89, 526, 515, 100, 654, 653,
	644, 646, 657, 658, 655, 656, 659, 661, 660, 662,
	647, 648, 649, 640, 642, 643, 641, 1002, 73, 526,
	526, 669, 11, 325, 99, 98, 78, 118, 672, 673,
	674, 675, 676, 521, 3, 0, 30, 0, 0, 0,
	1029, 0, 514, 0, 0, 0, 0, 444, 514, 514,
	0, 0, 0, 0, 0, 526, 0, 1040, 0, 144,
	150, 154, 0, 0, 0, 164, 0, 0, 0, 0,
	0, 0, 0, 197, 1054, 0, 0, 0, 205, 0,
	0, 0, 0, 444, 0, 0, 0, 0, 444, 222,
	0, 0, 0, 234, 235, 236, 237, 0, 0, 239,
	0, 241, 242, 243, 244, 245, 246, 247, 0, 0,
	0, 0, 0, 514, 261, 0, 0, 0, 0, 275,
	276, 0, 278, 279, 0, 0, 191, 0, 0, 0,
	0, 0, 0, 290, 514, 0, 0, 0, 747, 748,
	749, 750, 751, 752, 753, 754, 755, 756, 757, 758,
	759, 760, 761, 762, 763, 764, 765, 766, 767, 768,
	769, 770, 771, 772, 774, 176, 175, 669, 0, 0,
	0, 0, 0, 0, 514, 239, 0, 0, 337, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 0, 444, 444, 361, 362, 363,
	364, 365, 366, 367, 368, 369, 370, 371, 372, 373,
	374, 375, 376, 377, 378, 379, 380, 381, 0, 0,
	514, 154, 0, 0, 444, 514, 0, 444, 0, 444,
	0, 0, 0, 50, 0, 400, 402, 403, 404, 405,
	406, 407, 408, 409, 410, 411, 412, 413, 0, 514,
	514, 0, 0, 0, 0, 0, 0, 0, 153, 0,
	0, 0, 0, 0, 843, 0, 0, 0, 0, 0,
	846, 847, 0, 0, 0, 204, 239, 0, 426, 428,
	428, 0, 0, 0, 0, 514, 436, 0, 226, 226,
	169, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	154, 154, 0, 0, 461, 0, 0, 428, 0, 0,
	0, 0, 0, 428, 290, 0, 0, 0, 0, 428,
	428, 0, 0, 154, 0, 0, 428, 491, 192, 172,
	176, 175, 495, 0, 0, 904, 208, 209, 210, 211,
	213, 214, 215, 216, 217, 218, 219, 220, 212, 271,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 0,
	0, 168, 170, 169, 191, 0, 544, 0, 0, 0,
	0, 0, 0, 548, 549, 550, 551, 552, 0, 0,
	0, 0, 0, 350, 0, 0, 942, 0, 0, 0,
	0, 0, 0, 0, 0, 794, 793, 0, 0, 0,
	553, 192, 172, 176, 175, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 154, 387, 388, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 905, 0, 0, 416, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 597, 0, 0, 0, 0, 0, 0,
	0, 652, 650, 651, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 438, 0, 0, 610, 612, 0,
	0, 0, 0, 0, 0, 0, 0, 457, 459, 0,
	0, 620, 0, 0, 0, 0, 0, 0, 0, 637,
	0, 663, 645, 639, 638, 473, 0, 0, 0, 0,
	482, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 654, 653, 644, 646, 657, 658, 655,
	656, 659, 661, 660, 662, 647, 648, 649, 640, 642,
	643, 641, 0, 637, 337, 0, 645, 639, 638, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 696, 0, 0, 0, 652, 650, 651, 653, 644,
	646, 657, 658, 655, 656, 659, 661, 660, 662, 647,
	648, 649, 640, 642, 643, 641, 444, 0, 0, 0,
	0, 0, 0, 0, 444, 731, 0, 0, 0, 0,
	844, 428, 737, 637, 0, 663, 645, 639, 638, 0,
	154, 0, 0, 572, 0, 573, 0, 0, 0, 0,
	0, 637, 0, 0, 154, 639, 638, 654, 653, 644,
	646, 657, 658, 655, 656, 659, 661, 660, 662, 647,
	648, 649, 640, 642, 643, 641, 652, 650, 651, 657,
	658, 655, 656, 659, 661, 660, 662, 647, 648, 649,
	640, 642, 643, 641, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 637, 842, 663, 645, 639, 638,
	191, 0, 790, 0, 791, 0, 0, 473, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 654, 653,
	644, 646, 657, 658, 655, 656, 659, 661, 660, 662,
	647, 648, 649, 640, 642, 643, 641, 0, 172, 176,
	175, 0, 824, 0, 0, 0, 0, 0, 0, 0,
	428, 428, 0, 0, 0, 0, 0, 0, 840, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 0, 0,
	387, 700, 700, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	416, 416, 0, 0, 0, 0, 337, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 859, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 457, 0, 0,
	0, 0, 0, 0, 0, 473, 0, 473, 0, 0,
	0, 482, 0, 0, 0, 0, 428, 0, 0, 0,
	0, 0, 0, 0, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 15, 24,
	35, 0, 0, 36, 9, 0, 26, 0, 31, 80,
	81, 7, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 428, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 803, 0, 0, 0, 8,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	628, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 700, 0, 416, 22,
	23, 37, 44, 15, 24, 35, 0, 0, 36, 9,
	0, 26, 0, 31, 80, 81, 7, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 473, 0, 0, 0, 92,
	0, 0, 0, 0, 8, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 498, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 15, 24, 35, 0, 0, 36,
	9, 0, 26, 0, 31, 80, 81, 7, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 8, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 0, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 330, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 1061, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 330,
	45, 47, 49, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 46, 48, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 1051, 34,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	330, 45, 47, 49, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 1041,
	34, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 330, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	1006, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 1005, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 330, 45, 47, 49, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	46, 48, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 0, 34, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 330, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 983, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 330, 45, 47, 49, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 46, 48, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 982, 34, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 330, 45, 47, 49, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 46, 48, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 980, 34, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 979, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 330, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 0, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 921, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 330, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 0, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 852,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 330, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 0, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 330,
	45, 47, 49, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 46, 48, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 561, 34,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	330, 45, 47, 49, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 326,
	34, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 330, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	0, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 0, 34, 949, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 0, 34, 918, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 0, 34, 808, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 0, 0, 0, 0, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 0, 0, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 0, 34, 682, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 191, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 0, 34, 0, 62, 0,
	96, 172, 176, 175, 57, 56, 58, 59, 72, 119,
	168, 170, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 0, 0, 837, 0, 0, 0, 0, 0, 0,
	192, 172, 176, 175, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 0, 0, 832, 192, 172, 176, 175, 652, 650,
	651, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 780, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 783, 637, 0, 663, 645,
	639, 638, 652, 650, 651, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 741, 0, 0,
	654, 653, 644, 646, 657, 658, 655, 656, 659, 661,
	660, 662, 647, 648, 649, 640, 642, 643, 641, 0,
	637, 0, 663, 645, 639, 638, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 654, 653, 644, 646, 657, 658,
	655, 656, 659, 661, 660, 662, 647, 648, 649, 640,
	642, 643, 641, 0, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 738, 0, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	168, 170, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 695, 0, 0, 0, 0,
	192, 172, 176, 175, 0, 0, 0, 0, 168, 170,
	169, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 692, 0, 0, 0, 0, 0, 0, 192, 172,
	176, 175, 0, 0, 0, 0, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 627,
	0, 0, 0, 0, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 624, 0, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 168, 170,
	169, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 606, 0, 0, 192, 172,
	176, 175, 0, 0, 0, 0, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 587,
	0, 0, 0, 0, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 0, 0, 0, 0, 0, 471, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 192, 172, 176,
	175, 168, 170, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 399, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 423, 0,
	0, 192, 172, 176, 175, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 0, 0, 0, 192, 172, 176, 175, 0,
	0, 0, 168, 170, 169, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 392, 0, 0, 0,
	0, 0, 192, 172, 176, 175, 0, 0, 0, 168,
	170, 169, 191, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 343, 0, 0, 0, 0, 0, 192,
	172, 176, 175, 0, 0, 0, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 166, 167, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	341, 0, 0, 0, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 168, 170, 169, 191, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 165, 0, 0,
	0, 0, 0, 192, 172, 176, 175, 652, 650, 651,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 0, 637, 0, 663, 645, 639,
	638, 168, 170, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 654,
	653, 644, 646, 657, 658, 655, 656, 659, 661, 660,
	662, 647, 648, 649, 640, 642, 643, 641, 0, 0,
	0, 192, 172, 176, 175, 650, 651, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 637, 0, 663, 645, 639, 638, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 654, 653, 644, 646,
	657, 658, 655, 656, 659, 661, 660, 662, 647, 648,
	649, 640, 642, 643, 641, 0, 0, 192, 172, 176,
	175, 0, 651, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 637, 0,
	663, 645, 639, 638, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 654, 653, 644, 646, 657, 658, 655, 656,
	659, 661, 660, 662, 647, 648, 649, 640, 642, 643,
	641, 637, 0, 663, 645, 639, 638, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 654, 653, 644, 646, 657,
	658, 655, 656, 659, 661, 660, 662, 647, 648, 649,
	640, 642, 643, 641, 82, 83, 71, 0, 104, 105,
	125, 87, 120, 0, 0, 0, 0, 0, 94, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 44, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 484, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 147, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 637, 91, 76, 645,
	639, 638, 0, 62, 477, 96, 0, 0, 483, 57,
	56, 58, 59, 72, 119, 0, 0, 0, 0, 0,
	0, 0, 644, 646, 657, 658, 655, 656, 659, 661,
	660, 662, 647, 648, 649, 640, 642, 643, 641, 82,
	83, 71, 0, 104, 105, 125, 87, 120, 0, 0,
	0, 0, 0, 94, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 44, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 191, 0, 0, 148, 112, 108, 102, 484, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 145, 147, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 172,
	176, 175, 91, 76, 0, 0, 0, 0, 62, 0,
	96, 0, 0, 483, 57, 56, 58, 59, 72, 119,
	0, 0, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 82,
	83, 71, 0, 104, 105, 125, 87, 120, 0, 0,
	0, 0, 0, 94, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 44, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 145, 147, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 0, 0, 0, 0, 62, 0,
	96, 0, 0, 841, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 0, 104, 105, 125, 87, 120, 0,
	0, 0, 0, 0, 94, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 44, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 145, 147, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 0, 0, 0, 0, 62,
	0, 96, 0, 0, 613, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 0, 104, 105, 125, 87, 120,
	0, 0, 0, 0, 0, 94, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 44, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 191, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 145, 147, 0, 0, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 172, 176, 175, 91, 76, 0, 0, 0, 0,
	62, 0, 96, 0, 0, 611, 57, 56, 58, 59,
	72, 119, 0, 0, 0, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 82, 83, 71, 0, 104, 105, 125, 87, 120,
	0, 0, 0, 0, 0, 94, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 44, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 145, 147, 0, 0, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 0, 0, 0, 0,
	62, 0, 96, 0, 0, 291, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 0, 104, 105, 125, 87,
	120, 0, 0, 0, 0, 0, 94, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 44, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 191, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 147, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 0, 0, 0,
	0, 62, 425, 96, 172, 176, 175, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 0, 104, 105, 125,
	87, 120, 0, 0, 0, 0, 0, 94, 0, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 0, 0, 44, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 145, 147, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 0, 0,
	0, 0, 62, 0, 96, 0, 0, 401, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 0, 104, 105,
	125, 87, 120, 0, 0, 0, 0, 0, 94, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 44, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 145, 147, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 0,
	0, 151, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 0, 104,
	105, 125, 87, 120, 0, 0, 0, 0, 0, 94,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 44, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 145, 147,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	0, 0, 149, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 0,
	104, 105, 125, 87, 120, 0, 0, 0, 0, 0,
	94, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 44,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 145,
	147, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 0, 0, 143, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	145, 147, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 637,
	91, 76, 645, 639, 638, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 657, 658, 655,
	656, 659, 661, 660, 662, 647, 648, 649, 640, 642,
	643, 641, 82, 83, 71, 0, 104, 105, 125, 437,
	120, 0, 0, 0, 0, 0, 94, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 44, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 145, 147, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 0, 0, 0,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 0, 104, 105, 125,
	87, 120, 0, 0, 0, 0, 0, 94, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 44, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 104, 105, 125, 77, 41, 147, 0, 0,
	0, 0, 524, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 0, 0,
	0, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 519, 0, 522, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 525, 0,
	0, 0, 0, 517, 112, 108, 518, 104, 105, 125,
	0, 0, 0, 0, 0, 0, 0, 524, 0, 0,
	0, 0, 232, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 773, 531, 0, 520,
	0, 0, 0, 530, 529, 527, 528, 0, 0, 519,
	0, 522, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 525, 0, 0, 0, 0, 517, 112,
	108, 518, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 232, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 531, 0, 520, 0, 0, 0, 530, 529,
	527, 528,
}
var yyPact = [...]int{

	-1000, -1000, 2396, -1000, -1000, -1000, -1000, 368, 610, 667,
	172, -1000, 393, -1000, -1000, 953, -1000, 311, -1000, -1000,
	367, 311, 7592, 7461, 7330, 442, 229, 785, 7723, -1000,
	5796, 366, 365, -1000, -1000, 473, 7723, 951, 55, 946,
	943, 7723, -1000, -1000, -1000, -1000, 725, -1000, 723, -1000,
	1460, 364, 7723, 497, 286, 286, 7723, 7723, 7723, 7723,
	-1000, -1000, 8009, -1000, 7723, 7723, 7723, 7723, 7723, 7723,
	7723, 358, -1000, -1000, 232, 226, 883, 7723, 712, 363,
	354, 346, 7723, 7723, 345, 7723, 7723, -1000, 221, -1000,
	-1000, 881, 807, -1000, 220, 341, 6937, -1000, 219, 218,
	-1000, 317, 864, 660, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, 152, 197, -1000, 657, 314, -1000, 470,
	-1000, 309, 383, -1000, 864, -1000, 146, 674, 664, -1000,
	704, 864, -1000, 934, -1000, 3, 4099, 386, 8009, 311,
	4885, 7723, 344, -1000, 5749, -1000, 55, 752, 589, -1000,
	5702, -1000, 440, 1062, 5884, -1000, 129, -1000, -1000, 375,
	124, 55, -10, 116, 5884, -1000, -1000, -1000, -1000, -1000,
	7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723,
	7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723,
	7723, 363, 377, 286, 7723, 339, -1000, 5655, 439, 933,
	-1000, 717, -1000, -1000, 1460, 5608, -1000, -1000, 7199, 7723,
	7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723, 7723,
	7723, 203, -1000, -1000, -1000, -1000, -1000, 317, 553, 864,
	649, 644, -1000, -1000, -114, -114, -29, -114, 301, 5564,
	299, -114, -114, -114, -114, -114, -114, -114, -1000, 7068,
	-1000, 7723, 7723, 7723, 477, 739, 724, -1000, 247, 7878,
	286, -9, 155, 314, 631, -1000, 514, 550, 864, 709,
	152, 197, 621, 7723, 7723, 5884, 5884, 7723, 5884, 5884,
	7723, 606, 739, 775, -1000, 756, 7723, 6937, 194, 43,
	5520, 286, 7723, 7723, 897, -1000, 6220, 317, 156, 7723,
	7723, 152, 470, 176, -1000, 7723, 435, -1000, -1000, 2265,
	317, -1000, 676, 60, -1000, 703, 864, 52, -1000, 696,
	864, 895, 689, -25, 8169, -1000, -1000, -1000, -1000, -1000,
	337, 4885, -1000, -1000, 799, 434, 42, 5884, -1000, 433,
	432, -1000, -1000, -1000, -1000, -1000, -1000, 229, -1000, 7723,
	-1000, -1000, 842, -1000, 8169, -1000, 7723, 7723, 7723, 7723,
	7723, 1461, 6773, 1286, 7066, -30, -30, -30, -29, -114,
	-29, -29, 90, 90, 40, 40, 40, 40, 384, 384,
	384, 384, -1000, 7723, -1000, 108, -1000, -1000, 961, 783,
	894, 3968, -1000, -1000, -1000, 333, -1000, 611, 715, 7723,
	-9, 237, -9, -9, -9, -9, -9, -9, -9, -9,
	-9, -9, -9, -9, 107, -1000, -1000, 332, 864, 317,
	155, 155, -1000, -1000, -1000, -1000, -114, 182, 5884, 168,
	-1000, -1000, -1000, -1000, 902, 891, 5439, 215, 445, -1000,
	213, -1000, -1000, 152, 197, -1000, 7723, -1000, -1000, 163,
	864, 514, 155, 152, 163, 104, -1000, 1460, -1000, 931,
	298, 5391, 165, -1000, -1000, -1000, 160, 297, -1000, -1000,
	6787, 6656, -1000, -1000, 158, 150, -1000, -1000, 101, 277,
	-1000, -1000, 1460, 286, 7723, -1000, 314, 314, -1000, -1000,
	147, 5347, 314, 314, -1000, 5299, -1000, 2120, -1000, -1000,
	-1000, -1000, 674, 887, 677, -1000, 664, 886, 599, -1000,
	877, 8169, -1000, 5840, -1000, -1000, 514, 548, 864, 327,
	8169, -1000, -1000, -1000, -1000, 670, 598, 8169, 8169, 8169,
	8169, 8169, 276, -1000, -1000, 4754, -1000, 7723, -1000, 491,
	-1000, 917, -1000, -1000, 5251, -32, 325, -1000, 5884, 4883,
	6361, 5970, -9, 5203, 7723, 431, 286, 181, 181, 94,
	-50, 747, 320, 609, 705, -1000, 514, 544, 864, 465,
	611, -1000, 1460, -1000, 363, -54, 203, 203, 317, -1000,
	-1000, -1000, 142, -1000, -1000, -1000, -1000, -1000, 7723, -1000,
	-1000, 214, 205, 314, 7723, 7723, 152, 5157, -1000, 514,
	-1000, -1000, -1000, 7723, -1000, -1000, -1000, -1000, -1000, -1000,
	5109, 286, 5884, 286, -1000, -1000, -1000, 6375, -1000, -1000,
	5884, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, 871, -1000, -1000, 869, -1000, -1000, 8169, 8169, 8169,
	8169, 8169, 8169, 8169, 8169, 8169, 8169, 8169, 8169, 8169,
	8169, 8169, 8169, 8169, 8169, 8169, 8169, 8169, 8169, 8169,
	8169, 8169, 8169, 8094, 864, 514, 8169, 140, 36, 5065,
	669, 750, -79, -79, -3, -3, 5021, 423, -1000, 4230,
	-1000, -1000, -1000, 311, 421, 7723, -1000, 7723, 331, 478,
	420, 878, -1000, 8169, 609, -1000, 1880, -1000, -1000, 684,
	-1000, 286, 318, 684, 4623, 868, 8169, 741, 316, 609,
	272, -2, -1000, 55, -1000, -1000, -1000, 464, 611, 864,
	514, -1000, -11, -1000, -1000, 7723, -1000, 88, -1000, 177,
	-1000, 4977, 698, 7723, 7723, -1000, 139, 4933, -1000, 706,
	-1000, 6525, -1000, -1000, -1000, -1000, -1000, 1839, -3, -3,
	-79, -79, -79, -79, 251, 1776, 7714, -58, -58, -3,
	6013, 6056, 5927, 6211, 1698, -66, -66, -66, -66, 265,
	265, 265, 265, 8169, 1758, 514, 268, -1000, -1000, 8169,
	8169, -1000, -1000, -1000, -1000, 522, -1000, 3837, 419, 7723,
	5884, 1544, -1000, -1000, -1000, -1000, -1000, 413, -1000, 267,
	7723, 262, 181, -1000, 203, 259, -1000, -1000, -1000, -57,
	-1000, -1000, -1000, -1000, 254, 738, 609, 541, -1000, -11,
	514, 1093, 611, 314, -9, -1000, -1000, 198, 698, 7723,
	-1000, 155, 385, -1000, 120, 112, -1000, -1000, -1000, 155,
	5884, 286, -1000, 1099, 8169, -1000, 1654, 5840, -1000, 311,
	4885, 513, 412, -1000, 253, -1000, -1000, -1000, 738, 1880,
	4492, -1000, 86, 4492, 3706, 8169, 457, 611, 454, 453,
	313, -1000, 837, -1000, 693, -1000, -1000, -1000, -4, -1000,
	752, 614, -1000, 862, 611, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, 7723, 698, -1000, 85, -1000, -1000,
	-1000, -1000, -1000, -1000, 1099, 8169, -1000, -1000, 391, 311,
	376, -1000, 4361, -1000, 4230, 449, -1000, -1000, -1000, -1000,
	-1000, 406, -1000, -1000, -1000, -1000, -1000, 246, -60, -1000,
	835, -1000, 861, 55, -1000, -62, -46, -1000, 70, 698,
	-1000, -1000, 5840, 4885, 404, 370, -1000, -1000, -1000, -1000,
	4230, -1000, 3575, -1000, 3444, 834, 3313, 3182, -12, -1000,
	827, 8169, -52, -68, -71, 853, 8169, -1000, 611, -1000,
	675, -1000, -1000, -1000, -1000, -1000, 4230, 3051, 2920, 401,
	-1000, 243, -1000, -1000, -1000, 178, -1000, -1000, -1000, 822,
	8169, 8169, -1000, -1000, -1000, 347, 675, -1000, 399, 396,
	731, 769, 597, -1000, -1000, 395, -1000, -1000, -1000, -1000,
	817, -78, -1000, -1000, 266, -1000, -1000, -1000, -1000, 611,
	614, 852, 4230, -1000, 448, -1000, 8169, 609, -51, -1000,
	848, -1000, -1000, -1000, -1000, 242, 611, -1000, 2789, 374,
	-1000, -1000, -1000, -1000, -1000, 743, 2658, -1000, 743, -1000,
	199, -1000, -1000, 611, -1000, 792, 109, -1000, 447, -1000,
	2527, -1000,
}
var yyPgo = [...]int{

	0, 87, 1284, 49, 32, 36, 518, 1283, 1277, 172,
	278, 22, 18, 1286, 85, 57, 17, 821, 1493, 1276,
	34, 1275, 1274, 1273, 38, 1272, 45, 14, 1268, 1247,
	1246, 1244, 70, 1243, 1242, 33, 1238, 27, 37, 25,
	1237, 765, 35, 1236, 270, 1235, 1234, 44, 1233, 50,
	40, 39, 1232, 52, 0, 1231, 1230, 1223, 51, 1222,
	1221, 608, 1220, 1219, 54, 13, 1218, 8, 1034, 23,
	29, 1217, 1216, 1215, 16, 185, 1214, 1211, 1197, 1190,
	1189, 1188, 1187, 1186, 1154, 1153, 1152, 1151, 1150, 1149,
	24, 1147, 1146, 1145, 1143, 26, 6, 1142, 1141, 1139,
	1136, 1135, 1133, 1132, 1130, 1129, 1128, 1127, 1125, 2,
	1124, 1122, 30, 1121, 1119, 12, 1118, 1117, 1, 1116,
	1115, 1113, 1112, 11, 1095, 1094, 1092, 20, 47, 19,
	1091, 1090, 1089, 1088, 1087, 21, 1086, 1084, 48, 1082,
	1080, 1063, 1062, 1061, 1060, 1057, 1053, 1043, 1036, 1035,
	1033, 1032, 3, 1031, 1026, 1024, 1023, 1022, 1021, 4,
	1019, 1018, 1017, 7, 15, 1016, 1015, 1014, 1013, 1011,
	1010, 1008, 1007, 999, 996, 995, 994, 993, 988, 987,
	986, 984, 983, 750, 31, 979, 974, 28, 5, 973,
	966, 964, 891, 888,
}
var yyR1 = [...]int{

	0, 76, 53, 53, 54, 54, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 55, 55, 3,
	3, 3, 3, 56, 56, 4, 4, 4, 4, 57,
	57, 5, 5, 5, 5, 52, 52, 58, 58, 23,
	23, 23, 23, 24, 24, 25, 77, 78, 25, 81,
	82, 25, 85, 86, 25, 88, 89, 25, 25, 25,
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25,
	25, 25, 25, 25, 25, 25, 97, 25, 25, 25,
	25, 25, 100, 102, 103, 104, 105, 100, 101, 107,
	101, 106, 106, 108, 108, 110, 111, 109, 94, 94,
	112, 50, 51, 115, 115, 116, 116, 117, 113, 121,
	114, 125, 114, 119, 119, 119, 119, 120, 120, 124,
	126, 126, 122, 122, 127, 127, 95, 95, 69, 69,
	69, 91, 91, 96, 96, 99, 99, 98, 98, 92,
	92, 92, 92, 128, 130, 128, 131, 128, 129, 129,
	87, 87, 79, 132, 79, 83, 133, 83, 80, 80,
	84, 84, 118, 118, 134, 134, 135, 135, 136, 136,
	136, 136, 75, 75, 75, 137, 137, 138, 138, 138,
	138, 59, 59, 26, 26, 26, 60, 60, 60, 60,
	123, 123, 141, 139, 139, 139, 146, 139, 144, 148,
	148, 149, 149, 150, 150, 151, 151, 152, 152, 153,
	156, 156, 157, 157, 155, 154, 154, 158, 158, 147,
	147, 140, 140, 145, 145, 160, 160, 159, 159, 159,
	159, 159, 159, 142, 142, 142, 142, 143, 143, 93,
	93, 90, 90, 162, 161, 161, 163, 163, 165, 165,
	167, 166, 166, 166, 168, 169, 168, 41, 14, 14,
	14, 170, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	171, 14, 172, 14, 173, 14, 174, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 175, 14, 176, 177,
	14, 178, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 179, 14, 14, 14, 14, 14, 14, 14,
	181, 14, 182, 14, 49, 49, 49, 49, 46, 46,
	46, 46, 45, 45, 1, 67, 67, 66, 66, 66,
	66, 22, 22, 22, 22, 22, 22, 22, 22, 10,
	10, 10, 10, 44, 44, 44, 42, 42, 40, 40,
	72, 72, 73, 48, 48, 48, 180, 180, 180, 74,
	74, 6, 6, 6, 6, 6, 6, 6, 6, 6,
	6, 6, 6, 7, 27, 183, 183, 183, 183, 183,
	183, 183, 183, 183, 183, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 34, 34,
	34, 34, 28, 28, 28, 28, 28, 28, 28, 184,
	184, 187, 187, 186, 186, 186, 186, 13, 13, 47,
	47, 15, 16, 17, 18, 18, 189, 189, 190, 164,
	191, 191, 193, 192, 188, 188, 188, 39, 39, 43,
	43, 11, 21, 21, 19, 19, 19, 20, 20, 20,
	9, 9, 9, 8, 8, 12, 12, 70, 70, 71,
	71, 71, 38, 38, 68, 68, 65, 65, 37, 37,
	37, 64, 64, 63, 63, 63, 63, 63, 63, 63,
	63, 61, 61, 61, 61, 32, 32, 32, 32, 32,
	32, 33, 33, 33, 36, 36, 36, 36, 36, 36,
	36, 36, 62, 62, 35, 35, 29, 29, 30, 31,
}
var yyR2 = [...]int{

	0, 1, 2, 0, 1, 3, 1, 1, 1, 4,
	3, 5, 4, 3, 4, 4, 2, 3, 1, 1,
	3, 2, 4, 3, 1, 1, 3, 2, 4, 3,
	1, 1, 3, 2, 4, 5, 4, 2, 0, 1,
	1, 1, 4, 1, 2, 3, 0, 0, 7, 0,
	0, 10, 0, 0, 5, 0, 0, 7, 9, 3,
	2, 3, 2, 3, 2, 3, 3, 2, 3, 3,
	3, 1, 2, 5, 8, 8, 0, 6, 1, 6,
	3, 3, 0, 0, 0, 0, 0, 13, 0, 0,
	5, 1, 0, 1, 2, 0, 0, 10, 1, 3,
	1, 1, 1, 0, 1, 0, 1, 0, 10, 0,
	8, 0, 7, 1, 2, 1, 2, 0, 2, 1,
	0, 2, 0, 2, 1, 3, 0, 2, 1, 2,
	4, 1, 4, 1, 4, 1, 4, 3, 5, 3,
	4, 4, 5, 0, 0, 6, 0, 5, 1, 1,
	1, 4, 0, 0, 5, 0, 0, 6, 0, 2,
	0, 3, 1, 0, 1, 3, 4, 6, 0, 1,
	1, 1, 2, 3, 3, 1, 3, 1, 1, 2,
	2, 3, 1, 1, 2, 4, 3, 5, 1, 3,
	2, 0, 0, 4, 2, 1, 0, 9, 3, 1,
	3, 1, 3, 0, 1, 1, 2, 2, 2, 3,
	1, 3, 1, 1, 3, 4, 3, 0, 1, 1,
	3, 1, 1, 0, 1, 1, 2, 1, 1, 1,
	1, 1, 1, 3, 5, 1, 3, 5, 4, 3,
	1, 0, 1, 0, 4, 1, 2, 1, 4, 3,
	0, 3, 1, 1, 0, 0, 2, 3, 6, 3,
	4, 0, 7, 2, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 2, 2, 2, 2,
	0, 4, 0, 4, 0, 4, 0, 4, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 2, 2, 2, 2, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 1, 1, 0, 5, 0, 0,
	7, 0, 5, 1, 2, 2, 2, 2, 2, 2,
	2, 2, 0, 3, 1, 1, 1, 3, 2, 1,
	0, 10, 0, 11, 2, 2, 4, 4, 4, 4,
	4, 4, 4, 3, 1, 0, 4, 3, 4, 1,
	2, 2, 4, 3, 4, 4, 4, 4, 2, 1,
	1, 3, 2, 1, 3, 2, 1, 1, 4, 1,
	2, 0, 2, 0, 2, 1, 0, 1, 1, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 3, 2, 3, 1, 1, 1, 1, 3, 2,
	4, 3, 1, 1, 1, 4, 3, 3, 3, 3,
	3, 3, 2, 2, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 4, 5, 2, 2, 3, 1, 1,
	3, 2, 1, 1, 1, 1, 3, 3, 1, 0,
	2, 0, 1, 5, 3, 3, 1, 1, 1, 3,
	3, 1, 1, 1, 5, 1, 2, 0, 0, 4,
	4, 4, 0, 2, 1, 1, 0, 1, 2, 3,
	3, 1, 4, 4, 1, 1, 1, 1, 2, 1,
	4, 4, 1, 1, 4, 0, 1, 1, 1, 4,
	4, 1, 1, 3, 1, 2, 3, 1, 1, 4,
	0, 0, 2, 5, 3, 3, 1, 6, 4, 4,
	2, 2, 2, 1, 2, 1, 4, 3, 3, 6,
	3, 1, 1, 1, 4, 4, 4, 2, 2, 4,
	2, 2, 1, 3, 1, 1, 3, 3, 3, 3,
}
var yyChk = [...]int{

	-1000, -76, -53, -2, -24, -50, -51, 51, 79, 44,
	-52, -25, 10, -113, -114, 38, 119, 7, 21, 20,
	23, 30, 34, 35, 39, -49, 46, 98, 19, 14,
	-13, 48, 25, 27, 121, 40, 43, 36, -1, -119,
	-124, 97, -15, -14, 37, 52, 99, 53, 100, 54,
	-18, 59, 92, -17, 104, 105, 130, 129, 131, 132,
	-47, -41, 123, -36, 107, 108, 109, 110, 111, 112,
	113, 6, 133, -28, -46, -45, 118, 96, -19, 91,
	49, 50, 4, 5, 84, 85, 86, 11, -34, -31,
	-6, 117, 74, 62, 18, 60, 125, -20, -21, -22,
	-29, -54, 82, -10, 8, 9, 66, 67, 81, 63,
	64, 65, 80, -9, -68, -43, -11, -39, -8, 134,
	12, 123, -54, 119, 82, 10, -55, 37, 38, -3,
	-54, 82, 121, 135, 122, 10, -58, -47, 123, -85,
	-88, 123, -47, 121, -13, 97, -1, 98, 79, 121,
	-13, 121, -14, -18, -13, 121, -59, -26, 12, 134,
	-60, -1, 12, -93, -13, 121, 149, 150, 87, 89,
	88, 151, 128, 152, 163, 130, 129, 164, 167, 165,
	166, 161, 162, 155, 156, 153, 154, 157, 158, 159,
	160, 90, 127, 123, 123, -97, 119, -13, 10, -115,
	128, 10, 10, -14, -18, -13, 52, 52, 136, 137,
	138, 139, 148, 140, 141, 142, 143, 144, 145, 146,
	147, 123, -13, 104, 105, -17, -18, -54, 79, 82,
	-10, -11, 98, -17, -13, -13, -13, -13, -41, -13,
	-49, -13, -13, -13, -13, -13, -13, -13, -48, 123,
	-47, -179, 125, 125, -180, 17, -61, -32, 12, 76,
	77, -13, 57, -42, -10, -40, -54, 79, 82, -20,
	-9, -68, -11, 123, 123, -13, -13, 123, -13, -13,
	125, -61, 17, 17, 75, -61, 125, 123, -64, -63,
	-13, 128, 125, 125, 82, -75, 123, -54, 78, 125,
	119, -9, 134, 78, -75, 119, 124, 121, 119, -53,
	-54, 121, 135, -56, -4, -54, 82, -57, -5, -54,
	82, 29, -54, 10, 136, -23, 120, -24, -50, -51,
	51, -77, 122, -47, -24, -90, -161, -13, -92, 119,
	122, 121, -115, 121, 121, 121, 121, 135, -15, 119,
	-18, 121, 135, -115, 136, 121, 135, -171, -172, -173,
	-174, -13, -13, -13, -13, -13, -13, -13, -13, -13,
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13,
	-13, -13, -42, -176, 122, -94, -112, -18, -18, -14,
	123, -58, 121, 121, 10, -181, -120, 55, -125, 58,
	-13, 128, -13, -13, -13, -13, -13, -13, -13, -13,
	-13, -13, -13, -13, -65, -37, -18, 59, 82, -54,
	78, 78, 124, 124, 124, 124, -13, -12, -13, -12,
	118, -32, -32, 17, 125, 57, -13, 11, -18, -70,
	-71, -39, -38, -9, -68, 10, 119, -74, -75, 78,
	82, -54, 57, -9, 78, -62, -35, -18, -14, -18,
	-14, -13, -12, 117, 75, 75, -12, -64, 126, -187,
	135, 58, -16, -18, -12, -12, 10, 124, -137, -49,
	-138, -14, -18, 128, 83, -75, -38, -39, 10, 52,
	-12, -13, -38, -39, 10, -13, 121, -53, 120, -75,
	-3, 121, 135, 29, -54, 121, 135, 29, -54, 10,
	29, 136, -27, -183, -6, -30, -54, 79, 82, 60,
	125, -7, 62, -185, 18, 74, -10, 131, 132, 130,
	129, 123, 123, -24, -81, -86, 21, 121, 135, -128,
	121, -128, 121, -26, -13, 12, -182, -27, -13, -13,
	-13, -13, -13, -13, -178, 124, 135, 29, 29, -98,
	10, 120, -117, 123, -121, -44, -54, 79, 82, -126,
	55, -14, -18, -18, 91, 124, 135, 123, -54, -175,
	126, 126, -33, 10, 13, 12, 10, 120, 125, 120,
	-188, -192, -191, -193, 125, 119, -9, -13, -39, -54,
	-70, -39, 124, 135, 124, 124, 124, 126, 126, 124,
	-13, 128, -13, 128, 126, 126, 124, 135, 124, -16,
	-13, -75, -75, 126, 120, -75, -75, 120, 120, -4,
	10, 29, -5, 10, 29, 10, -27, 125, 130, 129,
	164, 167, 165, 166, 151, 128, 152, 161, 162, 163,
	88, 89, 87, 150, 149, 155, 156, 153, 154, 157,
	159, 158, 160, 127, 82, -54, 123, -184, -186, -183,
	17, 78, -183, -183, -183, -183, -183, 124, -78, -58,
	-87, -24, 122, -89, -90, -162, 120, 32, 33, -128,
	31, -128, 120, 136, 123, 122, -13, 121, -112, -69,
	-18, 128, 59, -69, 124, 135, 136, -100, 41, 123,
	-118, -134, -135, -136, 60, 61, -44, -122, 56, 82,
	-54, 119, -127, -44, -42, 136, -37, -65, -168, -169,
	126, -13, -189, 125, 125, -75, -12, -13, 120, -72,
	-35, 58, -16, -16, -138, 10, 10, -183, -183, -183,
	-183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
	-183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
	-183, -183, -183, 122, -183, -54, -184, 126, -187, 135,
	58, 10, 52, 124, 121, -79, -82, -58, -47, 121,
	-13, -13, -129, 122, 121, 120, 121, 31, -27, -118,
	-177, -95, 58, -18, 123, -95, -99, -24, 122, 10,
	-27, -101, 42, 123, -118, 124, 135, -115, 119, -127,
	-54, -123, 135, -170, -13, 124, -166, -165, -163, 125,
	-164, 57, 126, -164, -12, -12, 126, 120, -73, 57,
	-13, 128, 126, -183, 122, 124, -183, -183, -80, 93,
	94, -83, 22, 121, -90, -129, -131, 121, 124, -13,
	124, -69, -65, 124, -58, 136, -107, -102, 124, -67,
	44, -135, -116, 83, -123, 120, -139, -140, -143, -144,
	-145, -160, 47, 38, 44, -159, 103, 102, 101, 98,
	99, 100, -44, -74, 125, -167, -164, -12, -70, 120,
	126, 126, -70, -16, -183, 58, -47, -24, -84, 93,
	94, 121, 124, -130, -58, -67, -96, -24, 122, 124,
	-96, 28, -27, 119, -44, 119, 119, 123, 12, 120,
	-141, 121, 135, -1, -159, 10, -148, -44, -12, -163,
	126, -190, -183, -132, 95, -47, 122, -91, -24, 122,
	-58, 119, -58, 121, -58, -103, -58, -58, -66, 12,
	128, 136, -142, 12, 10, -115, 136, -149, 135, 121,
	119, 126, -188, -24, 121, 122, -58, -58, -58, 26,
	120, 12, 120, 120, 124, 135, 12, -27, 121, 135,
	136, 136, 10, -27, -44, -150, -151, -152, -153, -154,
	-155, -157, -44, 10, -133, 24, 120, 121, 124, 12,
	128, 12, -27, -27, -146, 120, -152, 121, 121, 45,
	29, 78, -58, 121, -104, 12, 136, 123, -156, -44,
	-158, -159, 10, 119, -27, -118, 135, 10, -58, 124,
	-44, 120, -147, 121, 119, -105, -58, -106, -108, -109,
	41, 120, -109, 123, -44, -110, 12, 124, -111, 119,
	-58, 120,
}
var yyDef = [...]int{

	3, -2, 1, 2, 6, 7, 8, 0, 0, 0,
	0, 43, 4, 101, 102, 0, 38, 0, 52, 55,
	0, 0, 0, 0, 0, 0, 0, 369, 0, 71,
	0, 0, 0, 76, 78, 0, 0, 0, 103, 0,
	0, 339, 467, 468, 354, 113, 0, 115, 0, 119,
	-2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	314, 315, 0, 323, 0, 0, 0, 0, 0, 0,
	0, 383, 332, 334, 335, 336, 386, 0, 475, 0,
	0, 0, 0, 0, 0, 0, 0, 452, 453, 454,
	455, 0, 0, 458, 393, 0, 521, 494, 495, 496,
	448, -2, 0, 0, 391, 392, 394, 395, 396, 397,
	398, 399, 400, -2, 0, 499, 0, 0, 502, 514,
	503, 0, 0, 3, 0, 4, 0, 0, 0, 18,
	19, 0, 16, 0, 44, 0, 0, 46, 0, 0,
	0, 241, 0, 60, 0, 339, 103, 369, 0, 62,
	0, 64, 468, -2, 0, 67, 0, 182, 183, 0,
	0, 103, 188, 0, 240, 72, 280, 282, 284, 286,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 318, 0, 0, 0, 38, 0, 0, 340,
	104, 117, 111, -2, -2, 0, 114, 116, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 520, 263, 276, 278, 277, 473, 370, 0, 0,
	0, 0, 369, 279, 301, 302, 303, 304, 315, 0,
	0, 324, 325, 326, 327, 328, 329, 330, 331, 0,
	385, 0, 505, 505, 0, 387, 388, 533, 535, 0,
	0, 338, 0, 389, 376, 377, 370, 0, 0, 379,
	-2, 0, 0, 0, 0, 547, 548, 0, 550, 551,
	505, 0, 0, 0, 402, 0, 505, 521, 0, 461,
	526, 0, 505, 505, 0, 361, 0, -2, 0, 505,
	0, -2, 515, 0, 368, 0, 0, 10, 3, 0,
	-2, 13, 0, 0, 24, 25, 0, 0, 30, 31,
	0, 0, 21, 0, 0, 37, 45, 39, 40, 41,
	0, 0, 49, 53, 0, 0, 242, 245, 59, 143,
	143, 61, 340, 63, 65, 66, 68, 0, 184, 0,
	471, 69, 0, 342, 0, 70, 0, 0, 0, 0,
	0, 288, 289, 290, 291, 292, 293, 294, 295, 296,
	297, 298, 299, 300, -2, -2, -2, -2, -2, -2,
	-2, -2, 313, 0, 321, 0, 98, 100, -2, 468,
	0, 0, 80, 81, 107, 0, 109, 0, 120, 0,
	259, 0, 264, 265, 266, 267, 268, 269, 270, 271,
	272, 273, 274, 275, 0, 517, 518, 0, 0, 372,
	0, 0, 316, 469, 470, 384, 333, 0, 506, 0,
	337, 534, 531, 532, 0, 0, 0, 452, 0, -2,
	507, 508, 511, 487, 0, 512, 0, 257, 390, 0,
	0, 372, 0, 498, 0, 0, 552, -2, -2, -2,
	468, 0, 0, 456, 401, 457, 0, 0, 353, 522,
	462, 0, 530, 472, 0, 0, 5, 172, 0, 0,
	175, -2, -2, 0, 0, 363, 0, 489, -2, 559,
	0, 0, 0, 490, -2, 0, 9, 0, 12, 362,
	17, 14, 0, 0, 27, 15, 0, 0, 33, 20,
	0, 0, 36, 404, 405, 406, -2, 0, 0, 0,
	459, 412, 413, 414, 393, 0, 0, 0, 0, 0,
	0, 0, 0, 47, 38, 0, 56, 241, 243, 0,
	143, 0, 143, 181, 0, 186, 0, 189, 239, 281,
	283, 285, 287, 0, 0, 0, 0, 0, 0, 0,
	0, 82, 0, -2, 122, 118, 373, 0, 0, 0,
	0, -2, -2, 260, 0, 0, 520, 520, 371, -2,
	349, 348, 0, 541, 542, 543, 537, 538, 0, 540,
	477, 484, 485, 0, 505, 0, 488, 0, 489, 371,
	381, 490, 544, 0, 545, 546, 549, 351, 350, 352,
	524, 0, 525, 0, 492, 493, 173, 0, 174, 179,
	180, 364, 365, 500, 501, 366, 367, 504, 11, 23,
	26, 0, 29, 32, 0, 22, 35, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, -2, 459, 0, 461, 466,
	0, 0, 422, 423, 445, 446, 0, 0, 152, 50,
	54, 150, 38, 0, 0, 0, 139, 0, 0, 0,
	0, 0, 185, 0, -2, 319, 322, 73, 99, 126,
	128, 0, 0, 126, 0, 0, 0, 88, 0, -2,
	0, 162, 164, 103, 169, 170, 171, 0, 0, 0,
	375, 191, 121, 124, 261, 0, 516, 0, 317, 0,
	536, 0, 474, 505, 505, 483, 0, 0, 513, 378,
	553, 0, 528, 529, 176, 28, 34, 0, 416, 417,
	418, 419, 420, 421, 424, 425, 426, 427, 428, 429,
	430, 431, 432, 433, 434, -2, -2, -2, -2, -2,
	-2, -2, -2, 0, 0, -2, 0, 411, 460, 462,
	0, 403, 558, 447, 42, 158, 155, 0, 0, 241,
	244, 0, 146, 148, 149, 140, 141, 0, 187, 0,
	0, 0, 0, 129, 520, 0, 77, 135, 38, 0,
	137, 79, 89, 83, 0, 355, 168, 105, 191, 123,
	374, 223, 0, 389, 258, 519, 256, -2, 253, 505,
	247, 0, 0, 476, 0, 0, 509, 510, 380, 0,
	523, 0, 415, 443, 0, 410, 464, 465, 48, 0,
	0, 160, 0, 57, 0, 144, 38, 142, 355, 320,
	0, 127, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 165, 0, 106, 223, 112, 190, 192, 0, 195,
	0, -2, 222, 0, 0, 225, 227, 228, 229, 230,
	231, 232, 125, 262, 505, 0, 246, 0, 478, 539,
	481, 480, 382, 527, 444, 0, 153, 159, 0, 0,
	0, 151, 0, 38, 147, 0, 74, 133, 38, 130,
	75, 0, 138, 38, 84, 38, 38, 0, 166, 110,
	0, 194, 0, 103, 226, 0, 0, 199, 0, 251,
	249, -2, 463, 0, 0, 0, 38, 58, 131, 38,
	145, 38, 0, 136, 0, 0, 0, 0, 0, 359,
	0, 0, 0, 235, 0, 0, 0, 198, 0, 201,
	203, 248, 479, 154, 51, 156, 161, 0, 0, 0,
	90, 0, 108, 341, 356, 0, 360, 167, 193, 0,
	0, 0, 196, 238, 200, 0, 204, 205, 0, 0,
	213, 0, 0, -2, 38, 0, 343, 134, 85, 357,
	0, 233, 236, 237, 0, 202, 206, 207, 208, 0,
	217, 0, 157, 132, 0, 358, 0, -2, 209, 210,
	0, -2, 214, 38, 234, 0, 0, 215, 0, 0,
	211, 86, 197, 219, 38, 92, 0, 87, 91, 93,
	0, 220, 94, 0, 95, 0, 0, 96, 0, 38,
	0, 97,
}
var yyTok1 = [...]int{

	1, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 131, 117, 3, 134, 166, 128, 3,
	123, 124, 164, 130, 135, 129, 163, 165, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 122, 121,
	157, 136, 159, 127, 133, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 125, 3, 126, 152, 3, 118, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 119, 151, 120, 132,
}
var yyTok2 = [...]int{

	2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
	22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
	42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
	52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
	62, 63, 64, 65, 66, 67, 68, 69, 70, 71,
	72, 73, 74, 75, 76, 77, 78, 79, 80, 81,
	82, 83, 84, 85, 86, 87, 88, 89, 90, 91,
	92, 93, 94, 95, 96, 97, 98, 99, 100, 101,
	102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
	112, 113, 114, 115, 116, 137, 138, 139, 140, 141,
	142, 143, 144, 145, 146, 147, 148, 149, 150, 153,
	154, 155, 156, 158, 160, 161, 162, 167,
}
var yyTok3 = [...]int{
	0,
}

var yyErrorMessages = [...]struct {
	state int
	token int
	msg   string
}{}

//line yaccpar:1

/*	parser for yacc output	*/

var (
	yyDebug        = 0
	yyErrorVerbose = false
)

type yyLexer interface {
	Lex(lval *yySymType) int
	Error(s string)
}

type yyParser interface {
	Parse(yyLexer) int
	Lookahead() int
}

type yyParserImpl struct {
	lval  yySymType
	stack [yyInitialStackSize]yySymType
	char  int
}

func (p *yyParserImpl) Lookahead() int {
	return p.char
}

func yyNewParser() yyParser {
	return &yyParserImpl{}
}

const yyFlag = -1000

func yyTokname(c int) string {
	if c >= 1 && c-1 < len(yyToknames) {
		if yyToknames[c-1] != "" {
			return yyToknames[c-1]
		}
	}
	return __yyfmt__.Sprintf("tok-%v", c)
}

func yyStatname(s int) string {
	if s >= 0 && s < len(yyStatenames) {
		if yyStatenames[s] != "" {
			return yyStatenames[s]
		}
	}
	return __yyfmt__.Sprintf("state-%v", s)
}

func yyErrorMessage(state, lookAhead int) string {
	const TOKSTART = 4

	if !yyErrorVerbose {
		return "syntax error"
	}

	for _, e := range yyErrorMessages {
		if e.state == state && e.token == lookAhead {
			return "syntax error: " + e.msg
		}
	}

	res := "syntax error: unexpected " + yyTokname(lookAhead)

	// To match Bison, suggest at most four expected tokens.
	expected := make([]int, 0, 4)

	// Look for shiftable tokens.
	base := yyPact[state]
	for tok := TOKSTART; tok-1 < len(yyToknames); tok++ {
		if n := base + tok; n >= 0 && n < yyLast && yyChk[yyAct[n]] == tok {
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}
	}

	if yyDef[state] == -2 {
		i := 0
		for yyExca[i] != -1 || yyExca[i+1] != state {
			i += 2
		}

		// Look for tokens that we accept or reduce.
		for i += 2; yyExca[i] >= 0; i += 2 {
			tok := yyExca[i]
			if tok < TOKSTART || yyExca[i+1] == 0 {
				continue
			}
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}

		// If the default action is to accept or reduce, give up.
		if yyExca[i+1] != 0 {
			return res
		}
	}

	for i, tok := range expected {
		if i == 0 {
			res += ", expecting "
		} else {
			res += " or "
		}
		res += yyTokname(tok)
	}
	return res
}

func yylex1(lex yyLexer, lval *yySymType) (char, token int) {
	token = 0
	char = lex.Lex(lval)
	if char <= 0 {
		token = yyTok1[0]
		goto out
	}
	if char < len(yyTok1) {
		token = yyTok1[char]
		goto out
	}
	if char >= yyPrivate {
		if char < yyPrivate+len(yyTok2) {
			token = yyTok2[char-yyPrivate]
			goto out
		}
	}
	for i := 0; i < len(yyTok3); i += 2 {
		token = yyTok3[i+0]
		if token == char {
			token = yyTok3[i+1]
			goto out
		}
	}

out:
	if token == 0 {
		token = yyTok2[1] /* unknown char */
	}
	if yyDebug >= 3 {
		__yyfmt__.Printf("lex %s(%d)\n", yyTokname(token), uint(char))
	}
	return char, token
}

func yyParse(yylex yyLexer) int {
	return yyNewParser().Parse(yylex)
}

func (yyrcvr *yyParserImpl) Parse(yylex yyLexer) int {
	var yyn int
	var yyVAL yySymType
	var yyDollar []yySymType
	_ = yyDollar // silence set and not used
	yyS := yyrcvr.stack[:]

	Nerrs := 0   /* number of errors */
	Errflag := 0 /* error recovery flag */
	yystate := 0
	yyrcvr.char = -1
	yytoken := -1 // yyrcvr.char translated into internal numbering
	defer func() {
		// Make sure we report no lookahead when not parsing.
		yystate = -1
		yyrcvr.char = -1
		yytoken = -1
	}()
	yyp := -1
	goto yystack

ret0:
	return 0

ret1:
	return 1

yystack:
	/* put a state and value onto the stack */
	if yyDebug >= 4 {
		__yyfmt__.Printf("char %v in %v\n", yyTokname(yytoken), yyStatname(yystate))
	}

	yyp++
	if yyp >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyS[yyp] = yyVAL
	yyS[yyp].yys = yystate

yynewstate:
	yyn = yyPact[yystate]
	if yyn <= yyFlag {
		goto yydefault /* simple state */
	}
	if yyrcvr.char < 0 {
		yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
	}
	yyn += yytoken
	if yyn < 0 || yyn >= yyLast {
		goto yydefault
	}
	yyn = yyAct[yyn]
	if yyChk[yyn] == yytoken { /* valid shift */
		yyrcvr.char = -1
		yytoken = -1
		yyVAL = yyrcvr.lval
		yystate = yyn
		if Errflag > 0 {
			Errflag--
		}
		goto yystack
	}

yydefault:
	/* default state action */
	yyn = yyDef[yystate]
	if yyn == -2 {
		if yyrcvr.char < 0 {
			yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
		}

		/* look through exception table */
		xi := 0
		for {
			if yyExca[xi+0] == -1 && yyExca[xi+1] == yystate {
				break
			}
			xi += 2
		}
		for xi += 2; ; xi += 2 {
			yyn = yyExca[xi+0]
			if yyn < 0 || yyn == yytoken {
				break
			}
		}
		yyn = yyExca[xi+1]
		if yyn < 0 {
			goto ret0
		}
	}
	if yyn == 0 {
		/* error ... attempt to resume parsing */
		switch Errflag {
		case 0: /* brand new error */
			yylex.Error(yyErrorMessage(yystate, yytoken))
			Nerrs++
			if yyDebug >= 1 {
				__yyfmt__.Printf("%s", yyStatname(yystate))
				__yyfmt__.Printf(" saw %s\n", yyTokname(yytoken))
			}
			fallthrough

		case 1, 2: /* incompletely recovered error ... try again */
			Errflag = 3

			/* find a state where "error" is a legal shift action */
			for yyp >= 0 {
				yyn = yyPact[yyS[yyp].yys] + yyErrCode
				if yyn >= 0 && yyn < yyLast {
					yystate = yyAct[yyn] /* simulate a shift of "error" */
					if yyChk[yystate] == yyErrCode {
						goto yystack
					}
				}

				/* the current p has no shift on "error", pop stack */
				if yyDebug >= 2 {
					__yyfmt__.Printf("error recovery pops state %d\n", yyS[yyp].yys)
				}
				yyp--
			}
			/* there is no state on the stack with an error shift ... abort */
			goto ret1

		case 3: /* no shift yet; clobber input char */
			if yyDebug >= 2 {
				__yyfmt__.Printf("error recovery discards %s\n", yyTokname(yytoken))
			}
			if yytoken == yyEofCode {
				goto ret1
			}
			yyrcvr.char = -1
			yytoken = -1
			goto yynewstate /* try again in the same state */
		}
	}

	/* reduction by production yyn */
	if yyDebug >= 2 {
		__yyfmt__.Printf("reduce %v in:\n\t%v\n", yyn, yyStatname(yystate))
	}

	yynt := yyn
	yypt := yyp
	_ = yypt // guard against "declared and not used"

	yyp -= yyR2[yyn]
	// yyp is now the index of $0. Perform the default action. Iff the
	// reduced production is ε, $1 is possibly out of range.
	if yyp+1 >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyVAL = yyS[yyp+1]

	/* consult goto table to find next state */
	yyn = yyR1[yyn]
	yyg := yyPgo[yyn]
	yyj := yyg + yyS[yyp].yys + 1

	if yyj >= yyLast {
		yystate = yyAct[yyg]
	} else {
		yystate = yyAct[yyj]
		if yyChk[yystate] != -yyn {
			yystate = yyAct[yyg]
		}
	}
	// dummy call; replaced with literal code
	switch yynt {

	case 1:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:222
		{
			rootnode = stmt.NewStmtList(yyDollar[1].list)
		}
	case 2:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:228
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 3:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:229
		{
			yyVAL.list = []node.Node{}
		}
	case 4:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:234
		{
			namePart := name.NewNamePart(yyDollar[1].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{namePart}
			comments.AddComments(namePart, yyDollar[1].token.Comments())
		}
	case 5:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:241
		{
			namePart := name.NewNamePart(yyDollar[3].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.list = append(yyDollar[1].list, namePart)
			comments.AddComments(namePart, yyDollar[3].token.Comments())
		}
	case 6:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:251
		{
			yyVAL.node = yyDollar[1].node
		}
	case 7:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:253
		{
			yyVAL.node = yyDollar[1].node
		}
	case 8:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:255
		{
			yyVAL.node = yyDollar[1].node
		}
	case 9:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:257
		{
			yyVAL.node = stmt.NewHaltCompiler()
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 10:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:263
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 11:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:273
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, yyDollar[4].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[5].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 12:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:283
		{
			yyVAL.node = stmt.NewNamespace(nil, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 13:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:289
		{
			yyVAL.node = stmt.NewUseList(nil, yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 14:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:295
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 15:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:305
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 16:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:315
		{
			yyVAL.node = yyDollar[1].node
		}
	case 17:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:320
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 18:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:322
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 19:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:327
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 20:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:337
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 21:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:350
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 22:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:360
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 23:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:376
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 24:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:378
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 25:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:383
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 26:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:393
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 27:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:406
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 28:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:416
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 29:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:432
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 30:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:434
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 31:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:439
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 32:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:449
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 33:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:462
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 34:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:472
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 35:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:488
		{
			name := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[3].token))
			comments.AddComments(name, yyDollar[3].token.Comments())

			constant := stmt.NewConstant(name, yyDollar[5].node, "")
			positions.AddPosition(constant, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[5].node))
			comments.AddComments(constant, yyDollar[3].token.Comments())

			constList := yyDollar[1].node.(*stmt.ConstList)
			constList.Consts = append(constList.Consts, constant)

			yyVAL.node = yyDollar[1].node
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeNodeListPosition(yyDollar[1].node, constList.Consts))
		}
	case 36:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:504
		{
			name := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(name, yyDollar[2].token.Comments())

			constant := stmt.NewConstant(name, yyDollar[4].node, "")
			positions.AddPosition(constant, positionBuilder.NewTokenNodePosition(yyDollar[2].token, yyDollar[4].node))
			comments.AddComments(constant, yyDollar[2].token.Comments())

			constList := []node.Node{constant}

			yyVAL.node = stmt.NewConstList(constList)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, constList))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 37:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:523
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 38:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:525
		{
			yyVAL.list = []node.Node{}
		}
	case 39:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:531
		{
			yyVAL.node = yyDollar[1].node
		}
	case 40:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:533
		{
			yyVAL.node = yyDollar[1].node
		}
	case 41:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:535
		{
			yyVAL.node = yyDollar[1].node
		}
	case 42:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:537
		{
			yyVAL.node = stmt.NewHaltCompiler()
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 43:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:547
		{
			yyVAL.node = yyDollar[1].node
		}
	case 44:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:549
		{
			label := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(label, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = stmt.NewLabel(label)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[2].token))

			comments.AddComments(label, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 45:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:561
		{
		}
	case 46:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:562
		{
		}
	case 47:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:562
		{
		}
	case 48:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:562
		{
		}
	case 49:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:563
		{
		}
	case 50:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:563
		{
		}
	case 51:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:563
		{
		}
	case 52:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:564
		{
		}
	case 53:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:564
		{
		}
	case 54:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:564
		{
		}
	case 55:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:565
		{
		}
	case 56:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:565
		{
		}
	case 57:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:565
		{
		}
	case 58:
		yyDollar = yyS[yypt-9 : yypt+1]
		//line php5/php5.y:566
		{
		}
	case 59:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:567
		{
		}
	case 60:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:568
		{
		}
	case 61:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:569
		{
		}
	case 62:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:570
		{
		}
	case 63:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:571
		{
		}
	case 64:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:572
		{
		}
	case 65:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:573
		{
		}
	case 66:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:574
		{
		}
	case 67:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:575
		{
		}
	case 68:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:576
		{
		}
	case 69:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:577
		{
		}
	case 70:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:578
		{
		}
	case 71:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:579
		{
		}
	case 72:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:580
		{
			yyVAL.node = yyDollar[1].node
		}
	case 73:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:581
		{
		}
	case 74:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:582
		{
		}
	case 75:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:583
		{
		}
	case 76:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:584
		{
		}
	case 77:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:584
		{
		}
	case 78:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:585
		{
		}
	case 79:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:586
		{
		}
	case 80:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:587
		{
		}
	case 81:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:588
		{
		}
	case 82:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:592
		{
		}
	case 83:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:593
		{
		}
	case 84:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:594
		{
		}
	case 85:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:595
		{
		}
	case 86:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:596
		{
		}
	case 87:
		yyDollar = yyS[yypt-13 : yypt+1]
		//line php5/php5.y:597
		{
		}
	case 88:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:600
		{
		}
	case 89:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:601
		{
		}
	case 90:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:601
		{
		}
	case 91:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:605
		{
		}
	case 92:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:606
		{
		}
	case 93:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:610
		{
		}
	case 94:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:611
		{
		}
	case 95:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:615
		{
		}
	case 96:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:615
		{
		}
	case 97:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:615
		{
		}
	case 100:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:624
		{
		}
	case 101:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:628
		{
		}
	case 102:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:632
		{
		}
	case 103:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:636
		{
		}
	case 104:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:637
		{
		}
	case 105:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:641
		{
		}
	case 106:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:642
		{
		}
	case 107:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:646
		{
		}
	case 108:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:648
		{
		}
	case 109:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:653
		{
		}
	case 110:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:657
		{
		}
	case 111:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:659
		{
		}
	case 112:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:663
		{
		}
	case 113:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:668
		{
		}
	case 114:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:669
		{
		}
	case 115:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:670
		{
		}
	case 116:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:671
		{
		}
	case 117:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:675
		{
		}
	case 118:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:676
		{
		}
	case 119:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:680
		{
		}
	case 124:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:694
		{
		}
	case 125:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:695
		{
		}
	case 126:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:699
		{
		}
	case 127:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:700
		{
		}
	case 128:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:705
		{
			yyVAL.foreachVariable = foreachVariable{yyDollar[1].node, false}
		}
	case 129:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:707
		{
			yyVAL.foreachVariable = foreachVariable{yyDollar[2].node, true}
		}
	case 130:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:709
		{
			list := expr.NewList(yyDollar[3].list)
			positions.AddPosition(list, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			yyVAL.foreachVariable = foreachVariable{list, false}
			comments.AddComments(list, yyDollar[1].token.Comments())
		}
	case 137:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:736
		{
		}
	case 138:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:737
		{
		}
	case 139:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:742
		{
		}
	case 140:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:743
		{
		}
	case 141:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:744
		{
		}
	case 142:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:745
		{
		}
	case 143:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:750
		{
		}
	case 144:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:751
		{
		}
	case 145:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:751
		{
		}
	case 146:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:752
		{
		}
	case 147:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:752
		{
		}
	case 153:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:771
		{
		}
	case 154:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:771
		{
		}
	case 156:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:777
		{
		}
	case 157:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:777
		{
		}
	case 166:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:806
		{
		}
	case 167:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:808
		{
		}
	case 168:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:813
		{
		}
	case 169:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:814
		{
		}
	case 170:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:815
		{
		}
	case 171:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:816
		{
		}
	case 172:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:822
		{
			yyVAL.nodesWithEndToken = &nodesWithEndToken{[]node.Node{}, yyDollar[2].token}
		}
	case 173:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:823
		{
		}
	case 174:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:824
		{
		}
	case 177:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:834
		{
		}
	case 178:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:835
		{
		}
	case 179:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:836
		{
		}
	case 180:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:837
		{
		}
	case 181:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:841
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 182:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:842
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 183:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:848
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 184:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:858
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 185:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:864
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 186:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:874
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[3].token))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 187:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:891
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[5].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[5].node))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 188:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:908
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[1].token))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 189:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:925
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[3].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[3].node))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 192:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:952
		{
		}
	case 196:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:955
		{
		}
	case 197:
		yyDollar = yyS[yypt-9 : yypt+1]
		//line php5/php5.y:957
		{
		}
	case 199:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:965
		{
		}
	case 200:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:966
		{
		}
	case 209:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:990
		{
		}
	case 210:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:994
		{
		}
	case 211:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:995
		{
		}
	case 212:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:999
		{
		}
	case 213:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1000
		{
		}
	case 214:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1004
		{
		}
	case 215:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1008
		{
		}
	case 216:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1009
		{
		}
	case 217:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1013
		{
		}
	case 218:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1014
		{
		}
	case 219:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1018
		{
		}
	case 220:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1019
		{
		}
	case 221:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1023
		{
		}
	case 222:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1024
		{
		}
	case 223:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1028
		{
		}
	case 224:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1029
		{
		}
	case 225:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1033
		{
		}
	case 226:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1034
		{
		}
	case 227:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1038
		{
		}
	case 228:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1039
		{
		}
	case 229:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1040
		{
		}
	case 230:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1041
		{
		}
	case 231:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1042
		{
		}
	case 232:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1043
		{
		}
	case 233:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1047
		{
		}
	case 234:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1048
		{
		}
	case 235:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1049
		{
		}
	case 236:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1050
		{
		}
	case 237:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1054
		{
		}
	case 238:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1055
		{
		}
	case 239:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1059
		{
		}
	case 240:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1060
		{
		}
	case 241:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1065
		{
		}
	case 242:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1066
		{
		}
	case 243:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1070
		{
		}
	case 244:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1070
		{
		}
	case 245:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1071
		{
		}
	case 246:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1075
		{
		}
	case 247:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1076
		{
		}
	case 248:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1080
		{
		}
	case 249:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1081
		{
		}
	case 250:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1085
		{
		}
	case 251:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1085
		{
		}
	case 252:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1086
		{
		}
	case 253:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1087
		{
		}
	case 254:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1091
		{
		}
	case 255:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1092
		{
		}
	case 256:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1093
		{
		}
	case 257:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1098
		{
			if yyDollar[3].nodesWithEndToken != nil {
				yyVAL.node = expr.NewNew(yyDollar[2].node, yyDollar[3].nodesWithEndToken.nodes)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].nodesWithEndToken.endToken))
			} else {
				yyVAL.node = expr.NewNew(yyDollar[2].node, nil)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			}

			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 258:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1113
		{
			list := expr.NewList(yyDollar[3].list)
			positions.AddPosition(list, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			yyVAL.node = assign_op.NewAssign(list, yyDollar[6].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[6].node))

			comments.AddComments(list, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 259:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1122
		{
		}
	case 260:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1123
		{
		}
	case 261:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1124
		{
		}
	case 262:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1124
		{
		}
	case 263:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1125
		{
		}
	case 264:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1126
		{
		}
	case 265:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1127
		{
		}
	case 266:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1128
		{
		}
	case 267:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1129
		{
		}
	case 268:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1130
		{
		}
	case 269:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1131
		{
		}
	case 270:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1132
		{
		}
	case 271:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1133
		{
		}
	case 272:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1134
		{
		}
	case 273:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1135
		{
		}
	case 274:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1136
		{
		}
	case 275:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1137
		{
		}
	case 276:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1138
		{
		}
	case 277:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1139
		{
		}
	case 278:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1140
		{
		}
	case 279:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1141
		{
		}
	case 280:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1142
		{
		}
	case 281:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1142
		{
		}
	case 282:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1143
		{
		}
	case 283:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1143
		{
		}
	case 284:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1144
		{
		}
	case 285:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1144
		{
		}
	case 286:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1145
		{
		}
	case 287:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1145
		{
		}
	case 288:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1146
		{
		}
	case 289:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1147
		{
		}
	case 290:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1148
		{
		}
	case 291:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1149
		{
		}
	case 292:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1150
		{
		}
	case 293:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1151
		{
		}
	case 294:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1152
		{
		}
	case 295:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1153
		{
		}
	case 296:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1154
		{
		}
	case 297:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1155
		{
		}
	case 298:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1156
		{
		}
	case 299:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1157
		{
		}
	case 300:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1158
		{
		}
	case 301:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1159
		{
		}
	case 302:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1160
		{
		}
	case 303:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1161
		{
		}
	case 304:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1162
		{
		}
	case 305:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1163
		{
		}
	case 306:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1164
		{
		}
	case 307:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1165
		{
		}
	case 308:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1166
		{
		}
	case 309:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1167
		{
		}
	case 310:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1168
		{
		}
	case 311:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1169
		{
		}
	case 312:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1170
		{
		}
	case 313:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1171
		{
		}
	case 314:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1172
		{
		}
	case 315:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1174
		{
			yyVAL.node = yyDollar[1].node
		}
	case 316:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1175
		{
		}
	case 317:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1175
		{
		}
	case 318:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1176
		{
		}
	case 319:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1177
		{
		}
	case 320:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1178
		{
		}
	case 321:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1179
		{
		}
	case 322:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1180
		{
		}
	case 323:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1181
		{
		}
	case 324:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1182
		{
		}
	case 325:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1183
		{
		}
	case 326:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1184
		{
		}
	case 327:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1185
		{
		}
	case 328:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1186
		{
		}
	case 329:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1187
		{
		}
	case 330:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1188
		{
		}
	case 331:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1189
		{
		}
	case 332:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1190
		{
		}
	case 333:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1190
		{
		}
	case 334:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1191
		{
			yyVAL.node = yyDollar[1].node
		}
	case 335:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1192
		{
		}
	case 336:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1193
		{
		}
	case 337:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1194
		{
		}
	case 338:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1195
		{
		}
	case 339:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1196
		{
		}
	case 340:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1197
		{
		}
	case 341:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:1199
		{
		}
	case 342:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1200
		{
		}
	case 343:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:1202
		{
		}
	case 344:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1206
		{
		}
	case 345:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1207
		{
		}
	case 346:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1208
		{
		}
	case 347:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1209
		{
		}
	case 348:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1214
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 349:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1220
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 350:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1226
		{
			str := scalar.NewString(yyDollar[1].token.Value)
			positions.AddPosition(str, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(str, yyDollar[1].token.Comments())

			yyVAL.node = expr.NewArrayDimFetch(str, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(str, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[str])
		}
	case 351:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1236
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 352:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1245
		{
			yyVAL.node = expr.NewArray(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 353:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1251
		{
			yyVAL.node = expr.NewShortArray(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 354:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1260
		{
			yyVAL.token = yyDollar[1].token
		}
	case 355:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1265
		{
			yyVAL.list = []node.Node{}
		}
	case 356:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1267
		{
			yyVAL.list = yyDollar[3].list
		}
	case 357:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1272
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))
			comments.AddComments(identifier, yyDollar[3].token.Comments())

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))
			comments.AddComments(variable, yyDollar[3].token.Comments())

			use := expr.NewClusureUse(variable, false)
			positions.AddPosition(use, positionBuilder.NewTokenPosition(yyDollar[3].token))
			comments.AddComments(use, yyDollar[3].token.Comments())

			yyVAL.list = append(yyDollar[1].list, use)
		}
	case 358:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1288
		{
			identifier := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[4].token))
			comments.AddComments(identifier, yyDollar[4].token.Comments())

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[4].token))
			comments.AddComments(variable, yyDollar[3].token.Comments())

			use := expr.NewClusureUse(variable, true)
			positions.AddPosition(use, positionBuilder.NewTokensPosition(yyDollar[3].token, yyDollar[4].token))
			comments.AddComments(use, yyDollar[3].token.Comments())

			yyVAL.list = append(yyDollar[1].list, use)
		}
	case 359:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1304
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(identifier, yyDollar[1].token.Comments())

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(variable, yyDollar[1].token.Comments())

			use := expr.NewClusureUse(variable, false)
			positions.AddPosition(use, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(use, yyDollar[1].token.Comments())

			yyVAL.list = []node.Node{use}
		}
	case 360:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1320
		{
			identifier := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(identifier, yyDollar[2].token.Comments())

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(variable, yyDollar[1].token.Comments())

			use := expr.NewClusureUse(variable, true)
			positions.AddPosition(use, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[2].token))
			comments.AddComments(use, yyDollar[1].token.Comments())

			yyVAL.list = []node.Node{use}
		}
	case 361:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1338
		{
		}
	case 362:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1339
		{
		}
	case 363:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1340
		{
		}
	case 364:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1341
		{
		}
	case 365:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1342
		{
		}
	case 366:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1343
		{
		}
	case 367:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1344
		{
		}
	case 368:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1345
		{
		}
	case 369:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1350
		{
			yyVAL.node = node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 370:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1356
		{
			yyVAL.node = name.NewName(yyDollar[1].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 371:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1362
		{
			yyVAL.node = name.NewRelative(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[3].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 372:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1368
		{
			yyVAL.node = name.NewFullyQualified(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 373:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1377
		{
			yyVAL.node = name.NewName(yyDollar[1].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 374:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1383
		{
			yyVAL.node = name.NewRelative(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[3].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 375:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1389
		{
			yyVAL.node = name.NewFullyQualified(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 376:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1398
		{
			yyVAL.node = yyDollar[1].node
		}
	case 377:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1400
		{
			yyVAL.node = yyDollar[1].node
		}
	case 378:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1405
		{
			yyVAL.node = yyDollar[1].node

			for _, f := range yyDollar[3].objectPropertyList {
				switch f.fetchType {
				case arrayFetchType:
					yyVAL.node = expr.NewArrayDimFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				case propertyFetchType:
					yyVAL.node = expr.NewPropertyFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				}
			}

			for _, f := range yyDollar[4].objectPropertyList {
				switch f.fetchType {
				case arrayFetchType:
					yyVAL.node = expr.NewArrayDimFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				case propertyFetchType:
					yyVAL.node = expr.NewPropertyFetch(yyVAL.node, f.node)
					positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, f.node))
					comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
				}
			}
		}
	case 379:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1435
		{
			yyVAL.node = yyDollar[1].node
		}
	case 380:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1441
		{
			yyVAL.objectPropertyList = append(yyDollar[1].objectPropertyList, yyDollar[2].objectPropertyList...)
		}
	case 381:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1443
		{
			yyVAL.objectPropertyList = []objectProperty{}
		}
	case 382:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1449
		{
			yyVAL.objectPropertyList = yyDollar[2].objectPropertyList
		}
	case 383:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1454
		{
			yyVAL.node = nil
		}
	case 384:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1456
		{
			yyVAL.node = nil
		}
	case 385:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1458
		{
			yyVAL.node = yyDollar[1].node
		}
	case 386:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1462
		{
		}
	case 387:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1463
		{
		}
	case 388:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1464
		{
		}
	case 389:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1469
		{
			yyVAL.nodesWithEndToken = nil
		}
	case 390:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1471
		{
			yyVAL.nodesWithEndToken = yyDollar[1].nodesWithEndToken
		}
	case 391:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1476
		{
			yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 392:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1482
		{
			yyVAL.node = scalar.NewDnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 393:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1488
		{
			yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 394:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1494
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 395:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1500
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 396:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1506
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 397:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1512
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 398:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1518
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 399:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1524
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 400:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1530
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 401:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1536
		{
			yyVAL.node = scalar.NewString(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token)) /* TODO: mark as Heredoc*/
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 402:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1541
		{
			yyVAL.node = scalar.NewEncapsed(nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 403:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1550
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 404:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1562
		{
		}
	case 405:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1566
		{
		}
	case 406:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1567
		{
		}
	case 407:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1568
		{
		}
	case 408:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1569
		{
		}
	case 409:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1570
		{
		}
	case 410:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1571
		{
		}
	case 411:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1572
		{
		}
	case 412:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1573
		{
		}
	case 413:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1574
		{
		}
	case 414:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1575
		{
		}
	case 415:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1579
		{
		}
	case 416:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1580
		{
		}
	case 417:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1581
		{
		}
	case 418:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1582
		{
		}
	case 419:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1583
		{
		}
	case 420:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1584
		{
		}
	case 421:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1585
		{
		}
	case 422:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1586
		{
		}
	case 423:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1587
		{
		}
	case 424:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1588
		{
		}
	case 425:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1589
		{
		}
	case 426:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1590
		{
		}
	case 427:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1591
		{
		}
	case 428:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1592
		{
		}
	case 429:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1593
		{
		}
	case 430:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1594
		{
		}
	case 431:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1595
		{
		}
	case 432:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1596
		{
		}
	case 433:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1597
		{
		}
	case 434:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1598
		{
		}
	case 435:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1599
		{
		}
	case 436:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1600
		{
		}
	case 437:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1601
		{
		}
	case 438:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1602
		{
		}
	case 439:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1603
		{
		}
	case 440:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1604
		{
		}
	case 441:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1605
		{
		}
	case 442:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1606
		{
		}
	case 443:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1607
		{
		}
	case 444:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1608
		{
		}
	case 445:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1609
		{
		}
	case 446:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1610
		{
		}
	case 447:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1611
		{
		}
	case 448:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1616
		{
			yyVAL.node = yyDollar[1].node
		}
	case 449:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1618
		{
			yyVAL.node = name.NewName(yyDollar[1].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 450:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1624
		{
			yyVAL.node = name.NewRelative(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[3].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 451:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1630
		{
			yyVAL.node = name.NewFullyQualified(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 452:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1639
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 453:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1649
		{
			yyVAL.node = yyDollar[1].node
		}
	case 454:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1651
		{
			yyVAL.node = yyDollar[1].node
		}
	case 455:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1653
		{
			yyVAL.node = yyDollar[1].node
		}
	case 456:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1655
		{
			yyVAL.node = scalar.NewEncapsed(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 457:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1661
		{
			yyVAL.node = scalar.NewEncapsed(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 458:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1667
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 459:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1675
		{
		}
	case 460:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1676
		{
		}
	case 463:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1685
		{
		}
	case 464:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1686
		{
		}
	case 465:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1687
		{
		}
	case 466:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1688
		{
		}
	case 467:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1693
		{
			yyVAL.node = yyDollar[1].node
		}
	case 468:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1695
		{
			yyVAL.node = yyDollar[1].node
		}
	case 469:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1700
		{
			yyVAL.node = yyDollar[2].node
		}
	case 470:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1702
		{
			yyVAL.node = yyDollar[2].node
		}
	case 471:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1708
		{
			yyVAL.node = yyDollar[1].node
		}
	case 472:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1716
		{
			yyVAL.node = yyDollar[1].node
		}
	case 473:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1723
		{
			yyVAL.node = yyDollar[1].node
		}
	case 474:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1730
		{
		}
	case 475:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1732
		{
			yyVAL.node = yyDollar[1].node
		}
	case 476:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1736
		{
		}
	case 477:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1737
		{
		}
	case 478:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1742
		{
		}
	case 479:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1742
		{
		}
	case 480:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1746
		{
		}
	case 481:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1747
		{
		}
	case 482:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1751
		{
		}
	case 483:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1752
		{
		}
	case 484:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1756
		{
		}
	case 485:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1757
		{
		}
	case 486:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1758
		{
		}
	case 487:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1763
		{
			yyVAL.node = yyDollar[1].node
		}
	case 488:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1765
		{
			yyDollar[1].simpleIndirectReference.last.SetVarName(yyDollar[2].node)

			for _, n := range yyDollar[1].simpleIndirectReference.all {
				positions[n] = positionBuilder.NewNodesPosition(n, yyDollar[2].node)
			}

			yyVAL.node = yyDollar[1].simpleIndirectReference.all[0]
		}
	case 489:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1778
		{
			yyVAL.node = expr.NewStaticPropertyFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 490:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1784
		{
			yyVAL.node = expr.NewStaticPropertyFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 491:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1794
		{
			yyVAL.node = yyDollar[1].node
		}
	case 492:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1799
		{
		}
	case 493:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1801
		{
		}
	case 494:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1805
		{
			yyVAL.node = yyDollar[1].node
		}
	case 495:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1806
		{
			yyVAL.node = yyDollar[1].node
		}
	case 496:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1807
		{
			yyVAL.node = yyDollar[1].node
		}
	case 497:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1813
		{
			yyVAL.node = yyDollar[1].node
		}
	case 498:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1815
		{
			yyDollar[1].simpleIndirectReference.last.SetVarName(yyDollar[2].node)

			for _, n := range yyDollar[1].simpleIndirectReference.all {
				positions[n] = positionBuilder.NewNodesPosition(n, yyDollar[2].node)
			}

			yyVAL.node = yyDollar[1].simpleIndirectReference.all[0]
		}
	case 499:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1825
		{
			yyVAL.node = yyDollar[1].node
		}
	case 500:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1830
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 501:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1836
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 502:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1842
		{
			yyVAL.node = yyDollar[1].node
		}
	case 503:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1848
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 504:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1858
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 505:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1866
		{
			yyVAL.node = nil
		}
	case 506:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1867
		{
			yyVAL.node = yyDollar[1].node
		}
	case 507:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1873
		{
			yyVAL.objectPropertyList = yyDollar[1].objectPropertyList
		}
	case 508:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1875
		{
			op := objectProperty{yyDollar[1].node, propertyFetchType}
			yyVAL.objectPropertyList = []objectProperty{op}
		}
	case 509:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1883
		{
			op := objectProperty{yyDollar[3].node, arrayFetchType}
			yyVAL.objectPropertyList = append(yyDollar[1].objectPropertyList, op)
		}
	case 510:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1888
		{
			op := objectProperty{yyDollar[3].node, arrayFetchType}
			yyVAL.objectPropertyList = append(yyDollar[1].objectPropertyList, op)
		}
	case 511:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1893
		{
			op := objectProperty{yyDollar[1].node, propertyFetchType}
			yyVAL.objectPropertyList = []objectProperty{op}
		}
	case 512:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1901
		{
			yyVAL.node = node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 513:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1907
		{
			yyVAL.node = yyDollar[2].node
		}
	case 514:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1912
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(n, yyDollar[1].token.Comments())

			yyVAL.simpleIndirectReference = simpleIndirectReference{[]*expr.Variable{n}, n}
		}
	case 515:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1920
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(n, yyDollar[2].token.Comments())

			yyDollar[1].simpleIndirectReference.last.SetVarName(n)

			yyDollar[1].simpleIndirectReference.all = append(yyDollar[1].simpleIndirectReference.all, n)
			yyDollar[1].simpleIndirectReference.last = n
			yyVAL.simpleIndirectReference = yyDollar[1].simpleIndirectReference
		}
	case 516:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1935
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 517:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1937
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 518:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1943
		{
			yyVAL.node = yyDollar[1].node
		}
	case 519:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1945
		{
			yyVAL.node = expr.NewList(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 520:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1951
		{
			yyVAL.node = nil
		}
	case 521:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1957
		{
			yyVAL.list = nil
		}
	case 522:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1959
		{
			yyVAL.list = yyDollar[1].list
		}
	case 523:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1964
		{
			arrayItem := expr.NewArrayItem(yyDollar[3].node, yyDollar[5].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[3].node, yyDollar[5].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 524:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1972
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[3].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodePosition(yyDollar[3].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 525:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1980
		{
			arrayItem := expr.NewArrayItem(yyDollar[1].node, yyDollar[3].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 526:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1988
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[1].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodePosition(yyDollar[1].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 527:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1996
		{
			arrayItem := expr.NewArrayItem(yyDollar[3].node, yyDollar[6].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[3].node, yyDollar[6].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 528:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2004
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[4].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[4].node))
			comments.AddComments(arrayItem, yyDollar[3].token.Comments())

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 529:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2012
		{
			arrayItem := expr.NewArrayItem(yyDollar[1].node, yyDollar[4].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[4].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 530:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2020
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[2].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(arrayItem, yyDollar[1].token.Comments())

			yyVAL.list = []node.Node{arrayItem}
		}
	case 531:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2031
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 532:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2033
		{
			encapsed := scalar.NewEncapsedStringPart(yyDollar[2].token.Value)
			positions.AddPosition(encapsed, positionBuilder.NewTokenPosition(yyDollar[2].token))
			yyVAL.list = append(yyDollar[1].list, encapsed)
			comments.AddComments(encapsed, yyDollar[2].token.Comments())
		}
	case 533:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2040
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 534:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2042
		{
			encapsed := scalar.NewEncapsedStringPart(yyDollar[1].token.Value)
			positions.AddPosition(encapsed, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{encapsed, yyDollar[2].node}
			comments.AddComments(encapsed, yyDollar[1].token.Comments())
		}
	case 535:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2052
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 536:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2062
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewArrayDimFetch(variable, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 537:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2075
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			fetch := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(fetch, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewPropertyFetch(variable, fetch)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(fetch, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 538:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2091
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 539:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:2097
		{
			identifier := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[2].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[2].token))
			yyVAL.node = expr.NewArrayDimFetch(variable, yyDollar[4].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[6].token))

			comments.AddComments(identifier, yyDollar[2].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 540:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2111
		{
			yyVAL.node = yyDollar[2].node
		}
	case 541:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2116
		{
			yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 542:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2122
		{
			// TODO: add option to handle 64 bit integer
			if _, err := strconv.Atoi(yyDollar[1].token.Value); err == nil {
				yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			} else {
				yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			}
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 543:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2134
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(identifier)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 544:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2147
		{
			yyVAL.node = expr.NewIsset(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 545:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2153
		{
			yyVAL.node = expr.NewEmpty(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 546:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2159
		{
			yyVAL.node = expr.NewEmpty(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 547:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2165
		{
			yyVAL.node = expr.NewInclude(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 548:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2171
		{
			yyVAL.node = expr.NewIncludeOnce(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 549:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:2177
		{
			yyVAL.node = expr.NewEval(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 550:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2183
		{
			yyVAL.node = expr.NewRequire(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 551:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:2189
		{
			yyVAL.node = expr.NewRequireOnce(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 552:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2198
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 553:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2200
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 554:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2204
		{
			yyVAL.node = yyDollar[1].node
		}
	case 555:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:2205
		{
			yyVAL.node = yyDollar[1].node
		}
	case 556:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2210
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 557:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2220
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 558:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2233
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 559:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:2246
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	}
	goto yystack /* stack new state and value */
}
